                Name    BLANKOUT
                Public  BlankOutStart,BlankOutStop,BlankOutTime,BlankOutSet

code    segment para    public  'code'
        assume  cs:code

old_kbdint      label   dword
old_kbdvec      dw      2 dup (?)       ;set aside a double word for old I/O
old_timerint    label   dword
old_timervec    dw      2 dup (?)       ;set aside a double word for old I/O

install         db      0
adapter         db      0
msr_address     dw      0
msr_values      db      2ch,28h,2dh,29h
                db      2ah,2eh,1eh,29h

switch          dw      00
isblank         db      00
blanktime       dw      300

vga_index       dw      00
vga_clock       dw      00

blank_on        db      00

;****************************************************************************
;* Keyboard interupt (INT 09H) comes here.                                  *
;*                                                                          *
;****************************************************************************
int_kbd         proc far
        push    ax                      ;save registers
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    ds
        push    es
        push    ds

        push    cs                      ;DS=CS
        pop     ds

        sti
        mov     al,blank_on             ;is function on ?
        cmp     al,1
        jz      kbd_1
        jmp     short exit              ;no exit

kbd_1:  xor     ax,ax                   ;set switch to zero
        mov     switch,ax
        mov     al,isblank              ;check if screen is blank
        cmp     al,1
	jnz     exit

	call    video_enable            ;enable video

	xor     ax,ax                   ;set screen to not_blank
	mov     isblank,al

;        in      al,61h                  ;reset keyboard
;        mov     ah,al
;        or      al,80h
;        out     61h,al
;        mov     al,ah
;        jmp     short $+2               ;I/O delay
;        out     61h,al
;        cli
;        mov     al,20h                  ;reset int controller
;        out     20h,al
;        sti
;        pop     ds
;        pop     es                      ;restore registers
;        pop     ds
;        pop     di
;        pop     si
;        pop     dx
;        pop     cx
;        pop     bx
;        pop     ax
;        iret                            ;return to caller

exit:   pop     ds
        pop     es                      ;restore registers
        pop     ds
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        jmp     old_kbdint              ;jump to old INT 9
int_kbd         endp

;****************************************************************************
;* Timer interupt (INT 1CH) comes here.                                     *
;*                                                                          *
;****************************************************************************
int_timer       proc far
        push    ax                      ;save registers
        push    bx
        push    cx
        push    dx
        push    si
        push    di
        push    ds
        push    es
        push    ds

        push    cs                      ;DS=CS
        pop     ds

        sti
        mov     al,blank_on             ;is function on ?
        cmp     al,1
        jz      t_1
        jmp     t_exit                  ;no exit

t_1:    mov     al,isblank              ;is screen blank
        cmp     al,0
        jnz     t_exit                  ;no need to change pointer

        mov     ax,switch               ;increment switch
        inc     ax
        mov     switch,ax

        cmp     ax,blanktime            ;how long until turnoff
        jle     t_exit

        call    video_disable

        mov     al,1
        mov     isblank,al

t_exit: pop     ds
        pop     es                      ;restore registers
        pop     ds
        pop     di
        pop     si
        pop     dx
        pop     cx
        pop     bx
        pop     ax
        jmp     old_timerint            ;jump to old INT 9

int_timer       endp

;****************************************************************************
;* VIDEO_DISABLE
;*      Disable Video.
;****************************************************************************
video_disable   proc    near
                cmp     adapter,4
                jge     dis_mcga_vga
                cmp     adapter,3
                jge     dis_pga
                cmp     adapter,2
                jge     dis_ega
                mov     ax,500
                mov     dx,msr_address          ;it's MDA/CGA/HERCULES
                mov     al,25h                  ;disable and return
                out     dx,al
                ret
dis_ega:        mov     dx,03bah
                in      al,dx
                mov     dx,03dah
                in      al,dx
                mov     dx,03c0h
                xor     al,al
                out     dx,al
                ret
dis_pga:        call    dis_ega
                ret
dis_mcga_vga:   mov     dx,03c4h
                in      ax,dx
                mov     vga_index,ax
                mov     ax,1
                out     dx,ax
                mov     dx,03c5h
                in      ax,dx
                mov     vga_clock,ax
                mov     ax,32
                out     dx,ax
                ret
video_disable   endp

;****************************************************************************
;* VIDEO_ENABLE
;*      Enable Video.
;****************************************************************************
video_enable    proc    near
                mov     al,adapter
                cmp     al,4
                jge     ena_mcga_vga
                cmp     al,3
                jge     ena_pga
                cmp     al,2
                jge     ena_ega

                mov     dx,msr_address          ;it's MDA/CGA/HERCULES
                mov     ah,15
                int     10h
                lea     bx,msr_values
                xlat    msr_values
                out     dx,al
                ret
ena_ega:        mov     dx,03bah
                in      al,dx
                mov     dx,03dah
                in      al,dx
                mov     dx,03c0h
                mov     al,20h
                out     dx,al
                ret
ena_pga:        call ena_ega
                ret
ena_mcga_vga:   mov     dx,03c5h
                mov     ax,vga_clock
                out     dx,ax
                mov     dx,03c4h
                mov     ax,vga_index
                out     dx,ax
                ret
video_enable    endp

;****************************************************************************
;* BlankOutStart:                                                           *
;*      Allocate IRQ to start BLANKOUT function.                            *
;****************************************************************************
BlankOutStart           proc    far
        push    bp                      ;save registers for QB
        mov     bp,sp
        push    si
        push    di
        push    ds                      ;save DS and set DS=CS
        push    cs
        pop     ds

        mov     ah,install              ;are we already installed
        cmp     ah,19
        jz      x_it                    ;yes skip all this

        xor     ax,ax                   ;clear AX
        call    QAdapter
        cmp     ax,-1                   ;was it unknown
        jnz     disp_found
        xor     ax,ax                   ;FALSE (no display ??)
        jmp     x_it

disp_found:
        push    cs                      ;make DS=CS
        pop     ds

        mov     al,09H                  ;Set al the the vector we use
        mov     ah,35H                  ;Use DOS-function call to get
        int     21H                     ;it's address.

        mov     old_kbdvec,bx           ;Old vector is returned in ES:BX
        mov     old_kbdvec[2],es        ;save it to old_io.

        mov     bx,cs                   ;DOS function wants vector in DS:DX
        mov     ds,bx
        mov     dx,offset int_kbd
        mov     al,09H                  ;Use DOS function call to set it.
        mov     ah,25H
        int     21H

        push    cs                      ;make DS=CS
        pop     ds

        mov     al,1CH                  ;Set al the the vector we use
        mov     ah,35H                  ;Use DOS-function call to get
        int     21H                     ;it's address.

        mov     old_timervec,bx         ;Old vector is returned in ES:BX
        mov     old_timervec[2],es      ;save it to old_io.

        mov     bx,cs                   ;DOS function wants vector in DS:DX
        mov     ds,bx
        mov     dx,offset int_timer
        mov     al,1CH                  ;Use DOS function call to set it.
        mov     ah,25H
        int     21H

        mov     ah,19                   ;set installed !
        mov     install,ah
        mov     ax,1                    ;return TRUE
x_it:
       pop      ds                      ;restore DS
       pop      di                      ;restore regs for QB
       pop      si                      ;and return
       pop      bp
       ret
BlankOutStart           endp

;****************************************************************************
;* BlankOutStop:                                                            *
;*      Restore IRQ to stop BLANKOUT function.                              *
;****************************************************************************
BlankOutStop            proc    far
        push    bp                      ;save registers for QB
        mov     bp,sp
        push    si
        push    di
        push    ds                      ;save DS, set DS=CS
        push    cs
        pop     ds

        mov     ah,install              ;are we installed
        cmp     ah,19
        jnz     x_it2                   ;no then skip all this

        lds     dx,dword ptr old_timerint
        mov     ax,251ch                ;restore TIMER
        int     21h

        lds     dx,dword ptr old_kbdint
        mov     ax,2509h                ;restore KEYBOARD
        int     21h

x_it2:
        pop      ds                     ;restore DS
        pop      di                     ;restore regs for QB
        pop      si                     ;and return
        pop      bp
        ret
BlankOutStop            endp

;****************************************************************************
;* BlankOutTime:                                                            *
;*      Set BLANKOUT time.                                                  *
;****************************************************************************
BlankOutTime            proc    far
        push    bp                      ;save registers for QB
        mov     bp,sp
        push    si
        push    di

        mov     bx,[bp+06]              ;get new blankout time
        mov     bx,[bx]

        push    ds                      ;save DS, set DS=CS
        push    cs
        pop     ds

        mov     blanktime,bx             ;yes, set time

        pop      ds                      ;restore DS
        pop      di                      ;restore regs for QB
        pop      si                      ;and return
        pop      bp
        ret      02
BlankOutTime            endp

;****************************************************************************
;* BlankOutSet:                                                             *
;*      Enable/Disable BLANKOUT function.                                   *
;****************************************************************************
BlankOutSet             proc    far
        push    bp                      ;save registers for QB
        mov     bp,sp
        push    si
        push    di

        mov     bx,[bp+06]              ;get flag
        mov     ax,[bx]

        push    ds                      ;save DS, set DS=CS
        push    cs
        pop     ds

        mov     blank_on,al             ;yes, set staus variable
        mov     al,isblank              ;check if screen is blank
        cmp     al,1
        jnz     set_ok
        call    video_enable
        xor     ax,ax                   ;set screen to not_blank
        mov     isblank,al
set_ok: xor     ax,ax                   ;set switch to zero
        mov     switch,ax

        pop      ds                      ;restore DS
        pop      di                      ;restore regs for QB
        pop      si                      ;and return
        pop      bp
        ret
BlankOutSet             endp



;****************************************************************************
;* QADAPTER
;*      Gets video_adapter type.
;****************************************************************************

QAdapter        proc    near

                push    bx                      ;save registers
                push    cx
                push    dx
                push    si
                push    di
                push    ds
                push    es

                mov     ah,1ah                  ;Try to get display
                mov     al,00h                  ;combination code.
                int     10h
                cmp     al,1ah                  ; did it work
                jnz     no_psvideo              ; no, check for EGA
                cmp     bl,00h
                jz      no_display              ;no display
                cmp     bl,01h
                jle     mda_display             ;mono
                cmp     bl,03h
                jle     cga_display             ;color graphics
                cmp     bl,05h
                jle     ega_display             ;enhanced graphics
                cmp     bl,06h
                jz      pga_display             ;professional graphics
                cmp     bl,08h
                jle     vga_display             ;VGA
                cmp     bl,0ch
                jle     mcga_display            ;MCA
                jmp     no_display

no_psvideo:     mov     ah,12h                  ;return EGA info
                mov     bl,10h
                int     10h

                cmp     bl,10h
                jz      mda_or_cga
                jmp     ega_display


mda_or_cga:     mov     ax,40h                  ;Get adapter
                push    ax
                pop     es
                mov     ax,es:[63h]             ;save msr_address
                add     ax,4
                mov     msr_address,ax

                mov     al,es:[10h]
                and     al,110000b
                cmp     al,30h
                je      mda_display             ;It is MDA
                jmp     cga_display

no_display:     mov     ax,-1
                jmp     found_adapter
mda_display:    mov     ax,00
                jmp     found_adapter
cga_display:    mov     ax,01
                jmp     found_adapter
ega_display:    mov     ax,02
                jmp     found_adapter
pga_display:    mov     ax,03
                jmp     found_adapter
vga_display:    mov     ax,05
                jmp     found_adapter
mcga_display:   mov     ax,04

found_adapter:  mov     adapter,al              ;screen adapter type
                pop     es                      ;restore registers
                pop     ds
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                ret

QAdapter        endp
code    ends
        end

