REM *************************************************************************
REM *
REM *        B T I S A M . M O D                                      931002
REM *
REM *        Library to use with VB-DOS 1.0
REM *
REM *
REM *************************************************************************

	'$INCLUDE: 'STLIBVB.BI'
	'$INCLUDE: 'BTISAM.BI'

	DEFINT A-Z

	DIM SHARED globalkey$

'       ---------------------------------------------------------------------
'        BtBof: Returns TRUE if passed beginning of file.             921206
'       ---------------------------------------------------------------------
	FUNCTION BtBof (bt AS BTFILETYPE)
	    IF bt.status = 9 THEN
	       BtBof = TRUE
	    ELSE
	       BtBof = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtClearOwner: Clears owner of file                           921205
'       ---------------------------------------------------------------------
	FUNCTION BtClearOwner (bt AS BTFILETYPE)

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOCLEAROWNER, status, bt.posblock, 0&, 0, "", 0)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtClearOwner = TRUE
	    ELSE
	       bt.status = status
	       BtClearOwner = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtClose: Instructs Betrieve to close a file.                 921205
'       ---------------------------------------------------------------------
	FUNCTION BtClose (bt AS BTFILETYPE)

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOCLOSE, status, bt.posblock, 0&, 0, "", 0)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtClose = TRUE
	    ELSE
	       bt.status = status
	       BtClose = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtCreate: Creates a new BTRIEVE file.                        921205
'       ---------------------------------------------------------------------
	FUNCTION BtCreate (sFileName$, btcf AS BTCFILESPECTYPE, btck() AS BTCKEYSPECTYPE, altcol$, bt AS BTFILETYPE)

	    ' Strings must have terminating ZERO.
	    '
	    szFileName$ = sFileName$ + CHR$(0)

	    ' Create the databuffer with fileinformation
	    '--------------------------------------------

	    ' Insert file spec into dbuf$
	    '
	    tmp$ = SPACE$(LEN(btcf))
	    CALL MemCopy(TSEGADD(btcf), SSEGADD(tmp$), LEN(btcf))
	    dbuf$ = tmp$

	    ' For each key insert key spec into dbuf$
	    '
	    FOR counter = 1 TO UBOUND(btck)
		tmp$ = SPACE$(LEN(btck(counter)))
		CALL MemCopy(TSEGADD(btck(counter)), SSEGADD(tmp$), LEN(btck(counter)))
		dbuf$ = dbuf$ + tmp$
	    NEXT

	    ' If alternate collating specified insert it also
	    '
	    IF LEN(altcol$) > 0 THEN
	       dbuf$ = dbuf$ + altcol$
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOCREATE, status, bt.posblock, SSEGADD(dbuf$), LEN(dbuf$), szFileName$, 0)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtCreate = TRUE
	    ELSE
	       bt.status = status
	       BtCreate = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtDelete: Deletes current record.                            921205
'       ---------------------------------------------------------------------
	FUNCTION BtDelete (bt AS BTFILETYPE)

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTODELETE, status, bt.posblock, 0&, lenRec, "", bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtDelete = TRUE
	    ELSE
	       bt.status = status
	       BtDelete = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtEof: Returns TRUE if passed end of file.                   921206
'       ---------------------------------------------------------------------
	FUNCTION BtEof (bt AS BTFILETYPE)
	    IF bt.status = 9 THEN
	       BtEof = TRUE
	    ELSE
	       BtEof = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtError: Returns error text.
'       ---------------------------------------------------------------------
	FUNCTION BtError$ (iErrorId)
	    SELECT CASE iErrorId
		   CASE 0
			sErr$ = "No error"
		   CASE 1
			sErr$ = "Invalid operation"
		   CASE 2
			sErr$ = "I/O error"
		   CASE 3
			sErr$ = "No Open"
		   CASE 4
			sErr$ = "Key not found"
		   CASE 5
			sErr$ = "Duplicates error"
		   CASE 6
			sErr$ = "Invalid key number"
		   CASE 7
			sErr$ = "Different key number"
		   CASE 8
			sErr$ = "Invalid positioning"
		   CASE 9
			sErr$ = "End of file"
		   CASE 10
			sErr$ = "Modifiable error"
		   CASE 11
			sErr$ = "Invalid file name"
		   CASE 12
			sErr$ = "File not found"
		   CASE 13
			sErr$ = "Extension error"
		   CASE 14
			sErr$ = "Pre-open error"
		   CASE 15
			sErr$ = "Pre-image error"
		   CASE 16
			sErr$ = "Expansion error"
		   CASE 17
			sErr$ = "Close error"
		   CASE 18
			sErr$ = "Disk full"
		   CASE 19
			sErr$ = "Unrecoverable error"
		   CASE 20
			sErr$ = "Record manager inactive"
		   CASE 21
			sErr$ = "Key buffer error"
		   CASE 22
			sErr$ = "Record buffer"
		   CASE 23
			sErr$ = "Position block"
		   CASE 24
			sErr$ = "Page size"
		   CASE 25
			sErr$ = "Create I/O error"
		   CASE 26
			sErr$ = "Number of keys"
		   CASE 27
			sErr$ = "Key position"
		   CASE 28
			sErr$ = "Record length"
		   CASE 29
			sErr$ = "Key length"
		   CASE 30
			sErr$ = "Btrieve file name"
		   CASE ELSE
			BtError$ = "Error name not in list"
	    END SELECT
	    BtError$ = STR$(iErrorId) + " " + sErr$
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetEqual: Gets record if key exists in database.           921205
'       ---------------------------------------------------------------------
	FUNCTION BtGetEqual (bt AS BTFILETYPE, pRec&, lenRec, key$, bLock)

	    ' Ensure that key is long enough.
	    '
	    tmpkey$ = key$ + STRING$(100, 0)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETEQUAL + iLockFlag, status, bt.posblock, pRec&, lenRec, tmpkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetEqual = TRUE
	    ELSE
	       bt.status = status
	       BtGetEqual = FALSE
	    END IF

	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetFirst: Gets first record in key sequence.               921213
'       ---------------------------------------------------------------------
	FUNCTION BtGetFirst (bt AS BTFILETYPE, pRec&, lenRec, bLock)

	    ' Probably no key larger than 100 bytes
	    '
	    globalkey$ = SPACE$(100)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETFIRST + iLockFlag, status, bt.posblock, pRec&, lenRec, globalkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetFirst = TRUE
	    ELSE
	       bt.status = status
	       BtGetFirst = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetGE: Gets equal or greater if exists.                    921205
'       ---------------------------------------------------------------------
	FUNCTION BtGetGE (bt AS BTFILETYPE, pRec&, lenRec, key$, bLock)

	    ' Ensure that key is long enough.
	    '
	    tmpkey$ = key$ + STRING$(100, 0)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETGREATEROREQUAL + iLockFlag, status, bt.posblock, pRec&, lenRec, tmpkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetGE = TRUE
	    ELSE
	       bt.status = status
	       BtGetGE = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetGreater: Get record with key greater than key$.         921205
'       ---------------------------------------------------------------------
	FUNCTION BtGetGreater (bt AS BTFILETYPE, pRec&, lenRec, key$, bLock)

	    ' Ensure that key is long enough.
	    '
	    tmpkey$ = key$ + STRING$(100, 0)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETGREATER + iLockFlag, status, bt.posblock, pRec&, lenRec, tmpkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetGreater = TRUE
	    ELSE
	       bt.status = status
	       BtGetGreater = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetLast: Gets last record in key sequence.                 921213
'       ---------------------------------------------------------------------
	FUNCTION BtGetLast (bt AS BTFILETYPE, pRec&, lenRec, bLock)

	    ' Probably no key larger than 100 bytes
	    '
	    globalkey$ = SPACE$(100)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETLAST + iLockFlag, status, bt.posblock, pRec&, lenRec, globalkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetLast = TRUE
	    ELSE
	       bt.status = status
	       BtGetLast = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetLE: Get record less than or equal key$.                 921205
'       ---------------------------------------------------------------------
	FUNCTION BtGetLE (bt AS BTFILETYPE, pRec&, lenRec, key$, bLock)

	    ' Ensure that key is long enough.
	    '
	    tmpkey$ = key$ + STRING$(100, 0)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETLESSTHANOREQUAL + iLockFlag, status, bt.posblock, pRec&, lenRec, tmpkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetLE = TRUE
	    ELSE
	       bt.status = status
	       BtGetLE = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetLess: Get record with key less than key$.               921205
'       ---------------------------------------------------------------------
	FUNCTION BtGetLess (bt AS BTFILETYPE, pRec&, lenRec, key$, bLock)

	    ' Ensure that key is long enough.
	    '
	    tmpkey$ = key$ + STRING$(100, 0)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETLESSTHAN + iLockFlag, status, bt.posblock, pRec&, lenRec, tmpkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetLess = TRUE
	    ELSE
	       bt.status = status
	       BtGetLess = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetNext: Gets next record in key sequence.                 921213
'       ---------------------------------------------------------------------
	FUNCTION BtGetNext (bt AS BTFILETYPE, pRec&, lenRec, bLock)

	    ' Probably no key larger than 100 bytes
	    '
	    globalkey$ = SPACE$(100)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETNEXT + iLockFlag, status, bt.posblock, pRec&, lenRec, globalkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetNext = TRUE
	    ELSE
	       bt.status = status
	       BtGetNext = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtGetPrevious: Get previous record in key sequence.          921213
'       ---------------------------------------------------------------------
	FUNCTION BtGetPrevious (bt AS BTFILETYPE, pRec&, lenRec, bLock)

	    ' Probably no key larger than 100 bytes
	    '
	    globalkey$ = SPACE$(100)

	    ' Lock or not.
	    '
	    IF bLock = TRUE THEN
	       iLockFlag = 200
	    ELSE
	       iLockFlag = 0
	    END IF

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOGETPREVIOUS + iLockFlag, status, bt.posblock, pRec&, lenRec, globalkey$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtGetPrevious = TRUE
	    ELSE
	       bt.status = status
	       BtGetPrevious = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtInsert: Inserts a record into file bf.                     921205
'       ---------------------------------------------------------------------
	FUNCTION BtInsert (bt AS BTFILETYPE, pRec&, lenRec)

	    ' Probably no key larger than 100 bytes
	    '
	    key$ = SPACE$(100)

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOINSERT, status, bt.posblock, pRec&, lenRec, key$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtInsert = TRUE
	    ELSE
	       bt.status = status
	       BtInsert = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtIsam: Executes the requested function.                     921205
'       ---------------------------------------------------------------------
	SUB BtIsam (op, status, sPB$, pDataBuf&, bLen, kb$, k)

	    ' Calculates the OFF:SEG values of databuffer.
	    '
	    sTemp$ = RIGHT$("0000000" + HEX$(pDataBuf&), 8)
	    bseg = VAL("&H" + LEFT$(sTemp$, 4))
	    boff = VAL("&H" + RIGHT$(sTemp$, 4))

	    ' Calls BTRIEVE BASIC I/O function.
	    '
	    CALL BTRVFAR(op, status, sPB$, boff, bseg, bLen, kb$, k)
	END SUB

'       ---------------------------------------------------------------------
'        BtLof: Returns length of file.                               921206
'       ---------------------------------------------------------------------
	FUNCTION BtLof& (bt AS BTFILETYPE)
	    ' key must be 64 bytes, only want file spec.
	    '
	    key$ = SPACE$(64)
	    DIM btt AS BTCFILESPECTYPE

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOSTAT, status, bt.posblock, TSEGADD(btt), 16, key$, 0)

	    ' Check status and set reurn values
	    '
	    IF status = 0 OR status = 22 THEN
	       bt.status = 0
	       BtLof& = btt.reccount
	    ELSE
	       bt.status = status
	       BtLof& = -1
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtOpen: Instructs Betrieve to open a file.                   921205
'       ---------------------------------------------------------------------
	FUNCTION BtOpen (sFileName$, sOwner$, iMode, bt AS BTFILETYPE)

	    ' Strings must have terminating ZERO.
	    '
	    szFileName$ = sFileName$ + CHR$(0)
	    szOwner$ = sOwner$ + CHR$(0)

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOOPEN, status, bt.posblock, SSEGADD(szOwner$), LEN(szOwner$), szFileName$, iMode)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtOpen = TRUE
	    ELSE
	       bt.status = status
	       BtOpen = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtReset: Close all files/unlock all locks.                   930821
'       ---------------------------------------------------------------------
	FUNCTION BtReset (bt AS BTFILETYPE, sConnectId$)

	    'Clear other station if specified
	    '
	    IF RTRIM$(sConnectId$) <> "" THEN
	       iTmp = VAL(sConnectId$)
	       hByte = iTmp \ &H1000
	       lByte = iTmp - (hByte * &H1000)
	       szBuffer$ = CHR$(lByte) + CHR$(hByte)
	       iFlag = -1
	    ELSE
	       szBuffer$ = ""
	       iFlag = 0
	    END IF

	    CALL BtIsam(BTORESET, status, "", 0&, 0, szBuffer$, iFlag)

	    ' Check status and set return values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtReset = TRUE
	    ELSE
	       bt.status = status
	       BtReset = FALSE
	    END IF

	END FUNCTION

'       ---------------------------------------------------------------------
'        BtSetOwner: Sets the owner of a file.                        921205
'       ---------------------------------------------------------------------
	FUNCTION BtSetOwner (bt AS BTFILETYPE, sOwner$, iRestrict)

	    ' Strings must have terminating ZERO.
	    '
	    szOwner$ = sOwner$ + CHR$(0)

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOSETOWNER, status, bt.posblock, SSEGADD(szOwner$), LEN(szOwner$), szOwner$, iRestrict)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtSetOwner = TRUE
	    ELSE
	       bt.status = status
	       BtSetOwner = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtTransAbort: Abort transaction.                             930821
'       ---------------------------------------------------------------------
	FUNCTION BtTransAbort (bt AS BTFILETYPE)

	    CALL BtIsam(BTOTRANSABORT, status, "", 0&, 0, "", 0)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtTransAbort = TRUE
	    ELSE
	       bt.status = status
	       BtTransAbort = FALSE
	    END IF

	END FUNCTION

'       ---------------------------------------------------------------------
'        BtTransBegin: Begin transaction.                             930821
'       ---------------------------------------------------------------------
	FUNCTION BtTransBegin (bt AS BTFILETYPE)

	    CALL BtIsam(BTOTRANSBEGIN, status, "", 0&, 0, "", 0)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtTransBegin = TRUE
	    ELSE
	       bt.status = status
	       BtTransBegin = FALSE
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        BtTransEnd: End transaction.                                 930821
'       ---------------------------------------------------------------------
	FUNCTION BtTransEnd (bt AS BTFILETYPE)

	    CALL BtIsam(BTOTRANSEND, status, "", 0&, 0, "", 0)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtTransEnd = TRUE
	    ELSE
	       bt.status = status
	       BtTransEnd = FALSE
	    END IF

	END FUNCTION

'       ---------------------------------------------------------------------
'        BtUnlock: Unlocks current record.                            930821
'       ---------------------------------------------------------------------
	FUNCTION BtUnlock (bt AS BTFILETYPE)

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOUNLOCK, status, bt.posblock, 0&, 0, "", 0)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtUnlock = TRUE
	    ELSE
	       bt.status = status
	       BtUnlock = FALSE
	    END IF

	END FUNCTION

'       ---------------------------------------------------------------------
'        BtUpdate: Updates the current record.                        921205
'       ---------------------------------------------------------------------
	FUNCTION BtUpdate (bt AS BTFILETYPE, pRec&, lenRec)

	    ' Probably no key larger than 100 bytes
	    '
	    key$ = SPACE$(100)

	    ' Let BtIsam handle posblock/SEG:OFF problematics
	    '
	    CALL BtIsam(BTOUPDATE, status, bt.posblock, pRec&, lenRec, key$, bt.curkey)

	    ' Check status and set reurn values
	    '
	    IF status = 0 THEN
	       bt.status = 0
	       BtUpdate = TRUE
	    ELSE
	       bt.status = status
	       BtUpdate = FALSE
	    END IF
	END FUNCTION

