		Name    clock
		Page    ,132
		Public  Clock
		Title   Clock.asm

code    segment byte    public  'code'
	assume  cs:code,ds:code

adapter         db      0
attribute       db      ?
clock_text      db      ?,?,58,?,?,58,?,?
counter         db      ?
old_int1c       dw      ?,?
status          db      0
video_buffer    dw      ?
video_offset    dw      ?

time            STRUC
		hrs     db      ?
		min     db      ?
		sec     db      ?
time            ENDS

current_time    time    <>


clock           proc    far

begin:          push    bp
		mov     bp,sp
		mov     si,[bp+12]
		mov     dh,[si]
		dec     dh
		mov     si,[bp+10]
		mov     dl,[si]
		dec     dl
		mov     si,[bp+8]
		mov     bl,[si]
		mov     si,[bp+6]
		mov     bh,[si]

		push    ds
		push    cs
		pop     ds

		cmp     bh,0
		je      terminate
		cmp     bh,1
		jne     exit

		call    initialize

		mov     ah,2ch
		int     21h
		mov     current_time.hrs,ch
		mov     current_time.min,cl
		mov     current_time.sec,dh

		mov     counter,1
		call    do_clock

		cmp     status,1
		je      exit
		mov     ax,351ch
		int     21h
		mov     old_int1c,bx
		mov     old_int1c[2],es

		mov     ax,251ch
		lea     dx,int1c
		int     21h
		mov     status,1
		jmp     short exit

terminate:      cmp     status,1
		jne     exit
		mov     status,0

		lds     dx,dword ptr old_int1c
		mov     ax,251ch
		int     21h

exit:           pop     ds
		pop     bp
		ret     8
clock           endp

int1c:          call    do_clock
		iret

do_clock        proc    near
		push    ax
		push    cx
		push    dx
		push    si
		push    di
		push    ds
		push    es

		push    cs
		pop     ds
		sti
		dec     counter
		jnz     done

		mov     cl,60
		mov     dx,180ah
		lea     di,clock_text[6]

		mov     al,current_time.sec
		inc     al
		cbw
		div     cl
		mov     current_time.sec,ah
		call    bin_to_ascii

		mov     al,current_time.min
		add     al,ch
		cbw
		div     cl
		mov     current_time.min,ah
		call    bin_to_ascii

		mov     al,current_time.hrs
		add     al,ch
		mov     current_time.hrs,al
		cbw
		div     dh
		cmp     ah,0
		jne     cont
		mov     ah,24
cont:           call    bin_to_ascii

		mov     clock_text[9],'p'
		cmp     ch,1
		je      write_time
		mov     clock_text[9],'a'

write_time:     mov     es,video_buffer
		lea     si,clock_text
		mov     ah,attribute
		mov     di,video_offset
		mov     dx,3dah
		mov     cx,8
		cld

output1:        cmp     adapter,2
		jne     output2
no_retrace:     in      al,dx
		test    al,1
		jne     no_retrace
retrace:        in      al,dx
		test    al,1
		je      retrace
output2:        lodsb
		stosw
		loop    output1

		mov     counter,18

done:           pop     es
		pop     ds
		pop     di
		pop     si
		pop     dx
		pop     cx
		pop     ax
		ret
do_clock        endp

bin_to_ascii    proc    near
		mov     ch,al
		mov     al,ah
		cbw
		div     dl
		add     al,48
		mov     [di],al
		inc     di
		add     ah,48
		mov     [di],ah
		sub     di,4
		ret
bin_to_ascii    endp

initialize      proc    near
		mov     al,160
		mul     dh
		shl     dl,1
		xor     dh,dh
		add     ax,dx
		mov     video_offset,ax

		mov     attribute,bl

		cmp     adapter,0
		jne     init_exit
		mov     ax,40h
		mov     es,ax
		mov     bx,0b000h
		mov     dl,1
		mov     al,es:[10h]
		and     al,110000b
		cmp     al,30h
		je      save_values
		add     bx,800h
		inc     dl
		mov     al,es:[87h]
		cmp     al,0
		je      save_values
		inc     dl
save_values:    mov     video_buffer,bx
		mov     adapter,dl
init_exit:      ret
initialize      endp

code            ends
end             begin




