REM     *********************************************************************
REM     * DATE.MOD
REM     *********************************************************************
REM     * FUNCTIONs
REM     *
REM     *********************************************************************
REM     * 901001: Created
REM     *********************************************************************
REM     * 931105: Split into DATE.MOD and TIME.MOD, func renames.
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        MonthLen: Returns array of iMonth length
'       ---------------------------------------------------------------------
	SUB MonthLen (iYear, aiMonthLen())
	    REDIM aiMonthLen(12)
	    FOR iCounter = 1 TO 12
		aiMonthLen(iCounter) = 31
	    NEXT iCounter
	    aiMonthLen(2) = 28
	    aiMonthLen(4) = 30
	    aiMonthLen(6) = 30
	    aiMonthLen(9) = 30
	    aiMonthLen(11) = 30
	    
	    IF (iYear MOD 4 = 0 AND iYear MOD 100 <> 0) OR (iYear MOD 400 = 0) THEN
	       aiMonthLen(2) = 29
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        DateNumber: Converts date to Serial number
'       ---------------------------------------------------------------------
	FUNCTION DateNumber (sDay$)
	    IF sDay$ = "" THEN
	       sDay$ = RIGHT$(DATE$, 2) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2)
	    END IF
	    dyear = VAL(LEFT$(sDay$, 2)) - 80
	    tyear = 1980 + dyear
	    REDIM mlen(1)
	    CALL MonthLen (tyear, mlen())
	    iMonth = VAL(MID$(sDay$, 3, 2))
	    iDay = VAL(RIGHT$(sDay$, 2))
	    ylen = 0
	    FOR counter = 1 TO dyear - 1
		temp = counter + 1980
		IF (temp MOD 4 = 0 AND temp MOD 100 <> 0) OR (temp MOD 400 = 0) = TRUE THEN
		   ylen = ylen + 366
		ELSE
		   ylen = ylen + 365
		END IF
	    NEXT counter
	    dyear = ylen
	    mlen = 0
	    FOR counter = 1 TO iMonth - 1
		mlen = mlen + mlen(counter)
	    NEXT counter
	    iMonth = mlen
	    DateNumber = dyear + iMonth + iDay
	END FUNCTION

'       ---------------------------------------------------------------------
'        DayOfWeek: Gets iDay of week from date$ string.
'       ---------------------------------------------------------------------
	FUNCTION DayOfWeek (sDay$)
	    REDIM mlen(12)
	    FOR counter = 1 TO 12
		mlen(counter) = 31
	    NEXT counter
	    mlen(2) = 28
	    mlen(4) = 30
	    mlen(6) = 30
	    mlen(9) = 30
	    mlen(11) = 30
	    IF sDay$ = "" THEN
	       sDay$ = RIGHT$(DATE$, 2) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2)
	    END IF
	    dyear = 1900 + VAL(LEFT$(sDay$, 2))
	    iMonth = VAL(MID$(sDay$, 3, 2))
	    iDay = VAL(RIGHT$(sDay$, 2))
	    days = 0
	    FOR counter = 1899 TO dyear - 1
		IF (temp MOD 4 = 0 AND temp MOD 100 <> 0) OR (temp MOD 400 = 0) THEN
		   days = days + (366 MOD 7)
		ELSE
		   days = days + (365 MOD 7)
		END IF
	    NEXT
	    FOR counter = 1 TO iMonth - 1
		days = days + mlen(counter)
	    NEXT
	    IF (dyear MOD 4 = 0 AND dyear MOD 100 <> 0) OR (dyear MOD 400 = 0) THEN
	       IF iMonth > 2 THEN
		  days = days + 1
	       END IF
	    END IF
	    days = days + iDay
	    DayOfWeek = days MOD 7
	END FUNCTION

'       ---------------------------------------------------------------------
'        NumberDate: Converts (Serial)date to datestring.
'       ---------------------------------------------------------------------
	FUNCTION NumberDate$ (number)
	    REDIM mlen(12)
	    FOR counter = 1 TO 12
		mlen(counter) = 31
	    NEXT counter
	    mlen(2) = 28
	    mlen(4) = 30
	    mlen(6) = 30
	    mlen(9) = 30
	    mlen(11) = 30
	    ylen = 0
	    FOR counter = 1 TO 20
		temp = counter + 1980
		IF (temp MOD 4 = 0 AND temp MOD 100 <> 0) OR (temp MOD 400 = 0) = TRUE THEN
		   ylen = ylen + 366
		   flag = TRUE
		ELSE
		   ylen = ylen + 365
		   flag = FALSE
		END IF
		IF ylen > Number THEN
		   dyear = counter
		   IF flag = TRUE THEN
		      temp = 366
		   ELSE
		      temp = 365
		   END IF
		   rest = Number - (ylen - temp)
		   EXIT FOR
		END IF
	    NEXT counter
	    tyear = 1980 + dyear
	    IF (tyear MOD 4 = 0 AND tyear MOD 100 <> 0) OR (tyear MOD 400 = 0) THEN
	       mlen(2) = 29
	    END IF
	    mlen = 0
	    FOR counter = 1 TO 12
		mlen = mlen + mlen(counter)
		IF mlen >= rest THEN
		   iMonth = counter
		   rest = rest - (mlen - mlen(counter))
		   EXIT FOR
		END IF
	    NEXT counter
	    iDay = rest
	    temp1$ = LTRIM$(STR$(iMonth))
	    IF LEN(temp1$) = 1 THEN
	       temp1$ = "0" + temp1$
	    END IF
	    temp2$ = LTRIM$(STR$(iDay))
	    IF LEN(temp2$) = 1 THEN
	       temp2$ = "0" + temp2$
	    END IF
	    NumberDate$ = LTRIM$(STR$(dyear + 80)) + temp1$ + temp2$
	END FUNCTION

