	Name    DIR_F

	Public  DosQMatches,DosGetDir,DosGetSubDir
	Public  DosMakeDir,DosRemoveDir,DosChangeDir

	Title   DIR_F.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        900311
;***************************************************************************

	extrn   STRINGADDRESS:far
	extrn   STRINGLENGTH:far

;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'
	fbuf    db      (?)             ;search attrib
		db      (?)             ;drive,
		db      11 dup (?)      ;name,
		dw      (?)             ;last ent
		dd      (?)             ;DPB,
		dw      (?)             ;dir start

xfattrib        db      (?)             ;attrib found,
		dw      (?)             ;time?
		dw      (?)             ;date?

	xfsize  dw      (?)             ;size low
		dw      (?)             ;size hi,
	xfname  db 13 dup (?)           ;packed name,

	strOff  dw      ?               ;string offset  BC7
	strSeg  dw      ?               ;string segment BC7
	StrLen  dw      ?               ;string length  BC7
	data    ends

	dgroup  group   data


;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

;----------------------------------------------------------------------------
; DosQMatches
;----------------------------------------------------------------------------
	DosQMatches     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		lea     dx,fbuf                 ;set DTA service in DS:DX
		mov     bx,dx                   ;put DTA adress into BX also
		add     bx,30
		mov     ah,1ah
		int     21h                     ;Set DTA adress

		mov     bx,[bp+08]              ;Get file address
		push    bx                      ;long strings
		call    STRINGADDRESS
		mov     strSeg,dx
		mov     strOff,ax

		push    bx
		mov     bx,[bp+06]              ;set attrib into
		mov     cx,[bx]                 ;cx-register
		pop     bx

		push    ds
		mov     dx,strOff               ;get far string
		mov     ds,strSeg               ;address and call
		mov     ah,4eh                  ;find first
		int     21h
		pop     ds
		xor     di,di                   ;set matches to 0
		jmp     dm_skip

dm_find_file:   push    cx
		int     21h
		pop     cx
dm_skip:        cmp     ax,18                   ;is it any more files ?
		jz      dm_exit                 ;no, then exit

		mov     al,xfattrib             ;Get file attribute found
		cmp     cl,16                   ;looking for subdirectory
		jnz     dm_files                ;no, jump files

		cmp     al,cl                   ;is it sub_dir ?
		jnz     dm_ignore               ;no, ignore
		jmp     short dm_use            ;yes, use it

dm_files:       jmp     short dm_use            ;yes, use it

dm_use:         inc     di                      ;yes, use it

dm_ignore:      mov     ah,4fh
		jmp     dm_find_file            ;find next matching entry

dm_exit:        mov     ax,di                   ;return matches
		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     4                       ;return 2xParameters
	DosQMatches           endp

;----------------------------------------------------------------------------
; DosGetDir
;----------------------------------------------------------------------------
	DosGetDir       proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si                      ;save si and di
		push    di

		push    ds                      ;dont know why !
		pop     es

		lea     dx,fbuf                 ;set DTA service expects DTA in DS:DX
		mov     bx,dx                   ;put DTA adress into BX also
		add     bx,30                   ;
		mov     ah,1ah                  ;
		int     21h                     ;call set DTA adress

		push    bx                      ;save bx

		mov     bx,[bp+06]              ;set attribute into
		mov     cx,[bx]                 ;cx-register.
		push    cx

		mov     bx,[bp+08]              ;get address of
		push    bx                      ;wildcard string
		call    STRINGADDRESS
		mov     strSeg,dx
		mov     strOff,ax

		mov     bx,[bp+10]              ;get address of
		mov     di,[bx]                 ;element zero
		mov     es,[bx+02]

		pop     cx                      ;restore cx
		pop     bx                      ;restore bx

		push    ds                      ;save ds
		mov     dx,strOff
		mov     ds,strSeg
		mov     ah,4eh                  ;find first match
		int     21h
		pop     ds                      ;restore ds

		jmp     short gd_skip

fond_file:      int     21h
gd_skip:        cmp     ax,18                   ;is it any more files ?
		jz      oxit                    ;no, then exit

		mov     al,xfattrib             ;get found attribute
		cmp     cl,16                   ;looking for subdirectory
		jnz     dor_files               ;no, jump files

		cmp     al,cl                   ;is it sub_dir ?
		jnz     dor_ignore              ;no, ignore
		jmp     short dor_use           ;yes, use it

dor_files:      jmp     short dor_use           ;yes, use it

dor_use:        push    cx                      ;save attribute
		mov     cx,13                   ;loop 13 characters
		lea     si,xfname               ;point to filename
dor_bloop:      mov     ah,[si]                 ;get first character
		cmp     ah,00h                  ;is it 20
		jz      dor_fill
		jmp     short dor_noblank       ;greater, dont change
dor_noblank:    inc     si                      ;inc
		loop    dor_bloop               ;and loop
		jmp     dor_cont1

dor_fill:       mov     ah,20h                  ;less or eq
		mov     [si],ah                 ;set to CHR$(32)
		inc     si
		loop    dor_fill

dor_cont1:
;               mov     ax,word ptr [bp+12]     ;length of type
;               add     di,ax                   ;add length to offset
		lea     si,xfattrib             ;direntry is ds:si
		mov     cx,22                   ;repeat 22 times
		cld
		repz    movsb                   ;block move

		pop     cx                      ;restore attribute
dor_ignore:     mov     ah,4fh
		jmp     fond_file               ;find next matching entry
oxit:
		pop     di                      ;restore di and si
		pop     si
		pop     ds
		pop     bp                      ;restore bp
		ret     06                      ;return to caller
	DosGetDir       endp

;----------------------------------------------------------------------------
; DosGetSubDir
;----------------------------------------------------------------------------
	DosGetSubDir    proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si                      ;save si and di
		push    di
		push    bp

		push    ds                      ;set es=ds
		pop     es

		lea     dx,fbuf                 ;set DTA service expects DTA in DS:DX
		mov     bx,dx                   ;put DTA adress into BX also
		add     bx,30                   ;
		mov     ah,1ah                  ;
		int     21h                     ;call set DTA adress

		mov     bx,[bp+08]              ;get address of
		push    bx                      ;wildcard string
		call    STRINGADDRESS
		mov     strSeg,dx
		mov     strOff,ax

		mov     bx,[bp+10]              ;get address of
		mov     di,[bx]                 ;element zero
		add     di,12
		mov     es,[bx+02]              ;skip array[0]

		xor     bx,bx                   ;clear counter
		push    ds                      ;save ds
		mov     dx,strOff
		mov     ds,strSeg
		mov     cx,16
		mov     ah,4eh                  ;find first match
		int     21h
		pop     ds                      ;restore ds
		jmp     short af_skip

afond_file:     mov     cx,16
		int     21h
af_skip:        jc      aoxit                   ;no, then exit

		mov     al,xfattrib             ;get found attribute
		cmp     al,16                   ;is it sub_dir ?
		jnz     ador_ignore             ;no, ignore
		jmp     short ador_use          ;yes, use it

ador_use:       lea     si,xfname               ;point to filename
		mov     ah,[si]                 ;get first char
		cmp     ah,'.'                  ;is it '.'
		jnz     ador_douse              ;no use it
		jmp     short ador_ignore       ;yes skip '.' or '..'

ador_douse:     inc     bx                      ;incr counter
		mov     cx,12                   ;loop 12 characters
		lea     si,xfname               ;point to filename
ador_bloop:     mov     ah,[si]                 ;get first character
		cmp     ah,00h                  ;is it 20
		jz      ador_fill
		jmp     short ador_noblank      ;greater, dont change
ador_noblank:   inc     si                      ;inc
		loop    ador_bloop              ;and loop
		jmp     ador_cont1

ador_fill:      mov     ah,20h                  ;less or eq
		mov     [si],ah                 ;set to CHR$(32)
		inc     si
		loop    ador_fill

ador_cont1:
		lea     si,xfname               ;direntry is ds:si
		mov     cx,12                   ;repeat 12 times
		cld
		repz    movsb                   ;block move

ador_ignore:    mov     ah,4fh
		jmp     afond_file              ;find next matching entry

aoxit:          pop     bp
		mov     bp,[bp+6]               ;return antal
		mov     [bp],bx
		pop     di                      ;restore di and si
		pop     si
		pop     ds
		pop     bp                      ;restore bp
		ret     06                      ;return to caller
	DosGetSubDir    endp

;---------------------------------------------------------------------------
; DosMakeDir
;---------------------------------------------------------------------------
	DosMakeDir        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+06]              ;Get file address
		push    bx                      ;long strings
		call    STRINGADDRESS
		mov     ds,dx
		mov     dx,ax
		mov     ah,39h
		int     21h
		jnc     md_ok                   ;check for failure
		mov     ax,0
		jmp     short md_exit
md_ok:          mov     ax,1

md_exit:        pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     02
	DosMakeDir        endp

;---------------------------------------------------------------------------
; DosRemoveDir
;---------------------------------------------------------------------------
	DosRemoveDir        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+06]              ;Get file address
		push    bx                      ;long strings
		call    STRINGADDRESS
		mov     ds,dx
		mov     dx,ax
		mov     ah,3Ah
		int     21h
		jnc     rd_ok                   ;check for failure
		mov     ax,0
		jmp     short rd_exit
rd_ok:          mov     ax,1

rd_exit:        pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     02
	DosRemoveDir        endp

;---------------------------------------------------------------------------
; DosChangeDir
;---------------------------------------------------------------------------
	DosChangeDir           proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		mov     bx,[bp+06]              ;Get file address
		push    bx                      ;long strings
		call    STRINGADDRESS
		mov     ds,dx
		mov     dx,ax
		mov     ah,3Bh
		int     21h
		jnc     cd_ok                   ;check for failure
		mov     ax,0
		jmp     short cd_exit
cd_ok:          mov     ax,1

cd_exit:        pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     02
	DosChangeDir           endp

	code    ends
		end
