	Name    FILE_F

	Public  DosGetSize,DosKill,DosMoveFile,DosCopyFile
	Public  DosGetAttr,DosSetAttr,DosQFile

	Title   FILE_F.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        900311
;***************************************************************************
;       DosGetSize                ver. 0.40
;       created: 870915         Updated: 880104         Timelog: 4h
;
;       This program gets the size of file 'filename$'
;
;       size=DosGetSize (filename$)
;            string     filename$ (file to check)
;            long       size      (size of file,0 if fnf)
;***************************************************************************
;       DosQFile                ver. 0.10
;       created: 860524         Updated: 880324         Timelog: 4h
;
;       This program tries to opens/creates a file using DOS call.
;       Filename$ is a ASCIZ string.
;
;       result=SysCreate(filename$,flag)
;            int        flag      (0=create, 1=open)
;            string     filename$
;            int        result    (0=NOT OK, 1=OK)
;***************************************************************************

	extrn   STRINGADDRESS:far
	extrn   STRINGLENGTH:far
	extrn   STRINGASSIGN:far

;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'

	source  dw      0
	target  dw      0
	buffer  dw      0
	bytes   dw      0
	time    dw      0
	date    dw      0
	root    db      ":\",0

	fbuf    db      (?)             ;search attrib
		db      (?)             ;drive,
		db      11 dup (?)      ;name,
		dw      (?)             ;last ent
		dd      (?)             ;DPB,
		dw      (?)             ;dir start

		db      (?)             ;attrib found,
		dw      (?)             ;time?
		dw      (?)             ;date?

	xfsize  dw      (?)             ;size low
		dw      (?)             ;size hi,
	xfname  db 13 dup (?)           ;packed name,

	bstrOff dw      ?
	bstrSeg dw      ?

	strOff  dw      ?               ;string offset  BC7
	strSeg  dw      ?               ;string segment BC7
	StrLen  dw      ?               ;string length  BC7

	data    ends

	dgroup   group   data

;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

;----------------------------------------------------------------------------
; DosGetSize
;----------------------------------------------------------------------------
	DosGetSize        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di
		mov     ah,1ah                  ;Set DTA adress
		mov     dx,offset dgroup:fbuf
		int     21h
		push    ds
		mov     bx,[bp+06]              ;Get file address
		push    bx                      ;of far string
		call    STRINGADDRESS
		mov     ds,dx
		mov     dx,ax
		mov     ah,4eh                  ;search for file
		mov     cx,0                    ;in directory
		int     21h
		pop     ds
		jnc     fs_ok
		xor     ax,ax
		xor     dx,dx
		jmp     short fs_exit
fs_ok:          mov     ax,dgroup:xfsize        ;return size of file
		mov     dx,dgroup:xfsize+2      ;in dx:ax
fs_exit:        pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     2                       ;return 2xParameters
	DosGetSize        endp

;----------------------------------------------------------------------------
; DosKill
;----------------------------------------------------------------------------
	DosKill       proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di
		mov     ax,[bp+06]              ;get string address
		push    ax
		call    STRINGADDRESS
		mov     ds,dx
		mov     dx,ax
		mov     ah,41h
		int     21h
		jnc     del_ok
		mov     ax,0
		jmp     short del_eop
del_ok:         mov     ax,1
del_eop:        pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     2                       ;return 2xParameters
	DosKill       endp

;----------------------------------------------------------------------------
; DosMoveFile
;----------------------------------------------------------------------------
	DosMoveFile         proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di
		mov     ax,[bp+08]              ;get string address
		push    ax
		call    STRINGADDRESS
		mov     strSeg,dx
		mov     strOff,ax
		mov     ax,[bp+06]              ;get string address
		push    ax
		call    STRINGADDRESS
		mov     es,dx
		mov     di,ax
		mov     dx,strOff
		mov     ds,strSeg
		mov     ah,56h
		int     21h
		jnc     movefile_ok
		mov     ax,0
		jmp     short movefile_exit
movefile_ok:    mov     ax,1
movefile_exit:  pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     4                       ;return 2xParameters
	DosMoveFile         endp

;----------------------------------------------------------------------------
; DosCopyFile
;----------------------------------------------------------------------------
	DosCopyFile         proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		push    ds
		pop     es
		xor     bx,bx
		cld

		mov     si,[bp+06]
		cmp     word ptr[si],-1
		jne     check_buffer
		jmp     close_files

check_buffer:   mov     ax,[bp+08]
		push    ax
		call    STRINGLENGTH
		mov     buffer,ax                      ;length of buffer
		cmp     ax,64
		ja      open_source
		mov     bx,13
		jmp     close_files

open_source:    mov     ax,[bp+08]
		push    ax
		call    STRINGADDRESS
		mov     bstrSeg,dx                     ;buffer address
		mov     bstrOff,ax
		mov     bx,[bp+12]              ;Get file address
		push    bx                      ;of far string
		call    STRINGADDRESS
		mov     strSeg,dx
		mov     strOff,ax
		mov     ax,[bp+12]              ;Get file lenght
		push    ax                      ;of far string
		call    STRINGLENGTH
		mov     strLen,ax
		mov     bx,1
		call    load_file
		push    ds
		mov     dx,bstrOff
		mov     ds,bstrSeg
		mov     ax,3d00h                        ;open source file
		int     21h
		pop     ds
		jnc     open_target
		call    find_err
		je      source_err
		inc     bx
source_err:     jmp     close_files

open_target:    mov     source,ax                       ;source handle
		mov     bx,ax
		mov     ax,5700h                        ;get date and time
		push    dx                              ;of source
		int     21h                             ;file
		mov     time,cx                         ;
		mov     date,dx
		pop     dx

		mov     ax,[bp+10]              ;Get file length
		push    ax                      ;of far string
		call    STRINGLENGTH
		mov     strLen,ax

		mov     ax,[bp+10]              ;Get file address
		push    ax                      ;of far string
		call    STRINGADDRESS
		mov     strSeg,dx
		mov     strOff,ax

		mov     bx,6
		call    load_file                       ;open target
		push    ds
		mov     dx,bstrOff
		mov     ds,bstrSeg
		mov     ah,3ch                          ;file like
		mov     cx,0                            ;source
		int     21h
		pop     ds
		jnc     prep_copy
		call    find_err
		jc      target_err
		je      target_err
		inc     bx
		test    ax,1
		jz      target_err
		inc     bx
target_err:     jmp     close_files

prep_copy:      mov     target,ax                       ;save target handle
		mov     cx,buffer                       ;buffer size
		push    ds
		pop     di
		push    ds
		mov     dx,bstrOff                      ;get address to
		mov     ds,bstrSeg                      ;far string (buffer)

do_copy:        mov     ah,3fh                          ;
		push    ds                              ;reclaim old DS
		push    di
		pop     ds
		mov     bx,source                       ;get source handle
		pop     ds
		int     21h                             ;read from source

		push    ds                              ;reclaim old DS
		push    di
		pop     ds
		mov     bytes,ax                        ;save read bytes
		mov     cx,ax                           ; and in cx
		mov     bx,target                       ;get target handle
		pop     ds
		mov     ah,40h                          ;call write
		int     21h                             ;

		mov     bx,12
		cmp     ax,cx
		jne     close_files                     ;loop while not
		push    ds                              ;reclaim old DS
		push    di
		pop     ds
		mov     cx,dgroup:buffer                ;eof source
		cmp     cx,dgroup:bytes                 ;
		pop     ds
		je      do_copy
		pop     ds
		mov     ax,5701h                        ;set the
		mov     bx,target                       ;same date
		mov     cx,time                         ;on target
		mov     dx,date                         ;as on
		int     21h                             ;source
		xor     bx,bx                           ;

close_files:    cmp     source,0                        ;close
		je      basic_return                    ;files
		push    bx                              ;
		cmp     target,0
		je      source_only
		mov     ah,3eh
		mov     bx,target
		int     21h
		mov     target,0
source_only:    mov     ah,3eh                          ;close
		mov     bx,source                       ;files
		int     21h
		mov     source,0

widow_check:    pop     bx
		cmp     bx,12
		jne     basic_return                    ;if there was
		mov     si,[bp+10]                      ;an error
		call    load_file                       ;delete this
		mov     ah,41h                          ;dir-entry
		int     21h

basic_return:   mov     ax,bx                           ;set err code
		pop     di
		pop     si
		pop     ds
		pop     bp
		ret     08                              ;return

load_file       proc    near
		mov     cx,strLen
		cmp     cx,64
		jbe     do_load
		add     sp,2
		jmp     close_files
do_load:        push    ds
		push    es
		mov     di,bstrOff
		mov     es,bstrSeg
		mov     si,strOff
		mov     ds,strSeg
		rep     movsb                   ;move s/t fname to buffer
		mov     byte ptr es:[di],0
		pop     es
		pop     ds
		ret
load_file       endp

find_err        proc    near
		cmp     ax,3
		je      end_find
		inc     bx
		cmp     ax,2
		je      end_find
		inc     bx
		mov     ax,4300h
		int     21h
		jc      end_find
		inc     bx
		mov     ax,cx
		xor     ax,0ffffh
		test    ax,10h
		je      end_find
		mov     cx,3
		mov     si,offset root
		mov     di,dx
		inc     di
		repe    cmps byte ptr [si], [di]
		clc
end_find:       ret
find_err        endp
	DosCopyFile         endp

;---------------------------------------------------------------------------
; DosQFile
;---------------------------------------------------------------------------
	DosQFile        Proc    Far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di
		mov     bx,[bp+06]
		mov     al,[bx]                 ;fileflag,
		push    ax
		mov     bx,[bp+08]              ;Get file address
		push    bx                      ;long strings
		call    STRINGADDRESS
		mov     ds,dx
		mov     dx,ax
		pop     ax
		cmp     al,0
		jnz     open_file
		mov     ah,60
		jmp     short try_it
open_file:      mov     ah,61
try_it:         xor     al,al                   ;access is read
		xor     bx,bx
		xor     cx,cx
		int     21h                     ;do it,
		jnc     oc_ok
		mov     ax,0                    ;error set flag to FALSE
		jmp     short oc_exit
oc_ok:          mov     bx,ax                   ;set file handle
		mov     ah,3eh                  ;close file
		int     21h
		mov     ax,1                    ;open ok set flag=TRUE
oc_exit:        pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     04                      ;return 2xParameters
	DosQFile        Endp

;---------------------------------------------------------------------------
; DosGetAttr
;---------------------------------------------------------------------------
	DosGetAttr    proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di
		mov     bx,[bp+06]              ;get attribute
		mov     cx,[bx]
		push    ds
		push    cx
		mov     bx,[bp+08]              ;Get file address
		push    bx                      ;long strings
		call    STRINGADDRESS
		mov     ds,dx
		mov     dx,ax
		pop     cx
		xor     al,al
		mov     ah,43h
		int     21h
		pop     ds
		jnc     gfa_ok
		mov     ax,0                    ;failure, return FALSE
		jmp     short gfa_exit
gfa_ok:         mov     ax,1
		mov     bx,[bp+06]              ;return attribute
		mov     [bx],cx
gfa_exit:       pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     04                      ;return 2xParameters
	DosGetAttr    endp

;---------------------------------------------------------------------------
; DosSetAttr:
;---------------------------------------------------------------------------
	DosSetAttr  proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di
		mov     bx,[bp+06]              ;get attribute
		mov     cx,[bx]
		push    cx
		mov     bx,[bp+08]              ;Get file address
		push    bx                      ;long strings
		call    STRINGADDRESS
		mov     ds,dx
		mov     dx,ax
		pop     cx
		mov     al,1
		mov     ah,43h
		int     21h
		jnc     cfa_ok
		mov     ax,0                    ;failure, return FALSE
		jmp     short cfa_exit
cfa_ok:         mov     ax,1
cfa_exit:       pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     04                      ;return 2xParameters
	DosSetAttr  endp

	code    ends
		end

