	Name    MOU_F

	Public  MouInit,MouShow,MouGetPos,MouDown,MouSetPos
	Public  KbdInt16,KbdClear
	Public  TSEGADD, MemCopy

	Title   MOU_F.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        921213
;***************************************************************************

	extrn   STRINGADDRESS:far
	extrn   STRINGLENGTH:far

;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'

	minst   dw      0
	mrow    dw      0
	mcol    dw      0
	mtime   dd      0
	mdbl    dw      0
	clicks  dw      0
	lclick  dw      0

	kbdtype db      0

	KeyCode dw      0

	strOff  dw      ?               ;string offset  BC7
	strSeg  dw      ?               ;string segment BC7
	StrLen  dw      ?               ;string length  BC7

	data    ends
	dgroup  group   data


;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

;***************************************************************************
; Divide8
;***************************************************************************
	Divide8         proc    far
		shr     cx,1                    ;divide with 8
		shr     cx,1
		shr     cx,1
		shr     dx,1
		shr     dx,1
		shr     dx,1
		inc     dx
		inc     cx
		mov     bx,[bp+06]              ;return parameters
		mov     [bx],ax
		mov     bx,[bp+08]
		mov     [bx],cx
		mov     bx,[bp+10]
		mov     [bx],dx
		ret
	Divide8         endp

;***************************************************************************
; MouseUp
;***************************************************************************
	MouseUp         proc    far
		xor     bx,bx
		mov     ax,6
		int     33h                     ;call mouse interupt
		cmp     bx,0                    ;check for no button
		jz      no_click
		mov     ax,1                    ;single click
		jmp     short click_exit
no_click:       xor     ax,ax
click_exit:     shr     cx,1                    ;divide with 8
		shr     cx,1
		shr     cx,1
		shr     dx,1
		shr     dx,1
		shr     dx,1
		inc     dx
		inc     cx
		mov     bx,ax
		mov     si,dx
		mov     di,cx
		mov     clicks,bx
		push    si
		push    di
		mov     ah,00                   ;read system timer
		int     1ah
		mov     ax,dx                   ;set time in
		mov     dx,cx                   ;dx:ax
		push    ax
		push    dx

		cmp     bx,0
		jz      mu_skip1
		mov     cx,lclick
		cmp     cx,2
		jz      mu_skip1
		cmp     bx,0
		jz      mu_skip
		mov     bx,mrow
		cmp     bx,si
		jnz     mu_skip
		mov     bx,mcol
		cmp     bx,di
		jnz     mu_skip
		mov     bx,word ptr [mtime+00]
		cmp     bx,dx
		jnz     mu_skip
		mov     bx,word ptr [mtime+02]
		add     bx,mdbl
		cmp     bx,ax
		jl      mu_skip
		mov     bx,2
		mov     clicks,bx
mu_skip:        pop     dx
		pop     ax
		mov     word ptr [mtime+02],ax
		mov     word ptr [mtime+00],dx
		jmp     short mu_skip2
mu_skip1:       add      sp,4
mu_skip2:       pop     di
		pop     si
		mov     mrow,si
		mov     mcol,di
		mov     bx,clicks
		mov     lclick,bx
		ret
	MouseUp         endp

;---------------------------------------------------------------------------
; MouInit
;---------------------------------------------------------------------------
	MouInit         proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		mov     bx,[bp+06]              ;get time
		mov     bx,[bx]
		mov     mdbl,bx
		xor     ax,ax
		int     33h                     ;call mouse interupt
		cmp     ax,-1
		jnz     mi_exit
		mov     ax,1
		mov     minst,ax
mi_exit:        pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     2                       ;return 2xParameters
	MouInit               endp

;---------------------------------------------------------------------------
; MouShow
;---------------------------------------------------------------------------
	MouShow      proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		mov     bx,[bp+06]              ;get m1 to m4
		mov     ax,[bx]
		cmp     ax,0
		jz      not_visible
		jmp     short visible_do_it
not_visible:    mov     ax,2
visible_do_it:  int     33h                     ;call mouse interupt
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     2                       ;return 2xParameters
	MouShow            endp

;---------------------------------------------------------------------------
; MouGetPos
;---------------------------------------------------------------------------
	MouGetPos               proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		mov     ax,3
		int     33h                     ;call mouse interupt
		mov     ax,bx                   ;set bx value in ax
		call    Divide8
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     6                       ;return 2xParameters
	MouGetPos               endp

;---------------------------------------------------------------------------
; MouDown
;---------------------------------------------------------------------------
	MouDown      proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		mov     ax,3
		int     33h                     ;call mouse interupt
		shr     cx,1                    ;divide with 8
		shr     cx,1
		shr     cx,1
		shr     dx,1
		shr     dx,1
		shr     dx,1
		inc     dx
		inc     cx
		mov     ax,bx
		mov     bx,[bp+06]
		mov     [bx],cx
		mov     bx,[bp+08]
		mov     [bx],dx
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     4                       ;return 2xParameters
	MouDown      endp

;---------------------------------------------------------------------------
; MouSetPos
;---------------------------------------------------------------------------
	MouSetPos        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		mov     ax,4
		mov     bx,[bp+08]              ;get m1 to m4
		mov     dx,[bx]
		mov     bx,[bp+06]
		mov     cx,[bx]
		dec     dx
		dec     cx
		shl     dx,1
		shl     dx,1
		shl     dx,1
		shl     cx,1
		shl     cx,1
		shl     cx,1
		int     33h                     ;call mouse interupt
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     4                       ;return 2xParameters
	MouSetPos        endp

;---------------------------------------------------------------------------
; KbdInt16
;---------------------------------------------------------------------------
	KbdInt16        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di

		mov     ah,kbdtype              ;is keyboard type known ?
		cmp     ah,0
		jnz     kbdok                   ; yes skip on

		mov     dl,2                    ; make two attempts to write
		mov     cx,0ffffh               ;char/scan of FFFF to
kbdwrite:       mov     ah,05h                  ;buffer via extended keyboard
		int     16h
		or      al,al                   ; was it successfull ?
		jz      maybeok                 ;If yes, extended should work
		mov     ah,10h                  ;   else buffer full make 
		int     16h                     ;   room with retrieve
		dec     dl                      ; decrease loopvar
		jnz     kbdwrite                ; try again

kbdnosupp:      mov     ah,1                    ; no support for Ext. kbd
		mov     kbdtype,ah              ; set type 
		jmp     kbdok                   ; continue

maybeok:        mov     cx,15                   ; try 15 times to retrieve 
searchkbd:      mov     ah,11h                  ; sacncode FFFF
		int     16h                     ;
		jz      kbdnosupp               ; if buffer empty no ext.
		mov     ah,10h                  ;
		int     16h                     ; extended read
		cmp     ax,0ffffh               ; Did we find FFFF ?
		jz      kbdsupp                 ;     YES its extended
		loop    searchkbd               ;     No try again
		jmp     kbdnosupp               ; When we get here=nonext

kbdsupp:        mov     ah,2                    ; support for Ext. kbd
		mov     kbdtype,ah

; Though the check for normal or extended keyboard is there and
; the status value is saved its not used in the rest of this sub.

kbdok:
		mov     ax,minst                ;is mouse enabled ?
		cmp     ax,1
		jz      ki_mouse

		mov     bx,[bp+16]              ;IDKWAIT or IDKNOWAIT
		mov     ah,[bx]                 ; (0)          (1)
		cmp     ah,0
		jnz     no_wait
;------------------WAIT FOR KEY      (KEYBOARD VERSION)---------------------
k_wait:         xor     ah,ah                   ;wait for keypress
		int     16H
		jmp     short got_key
;------------------DONT WAIT FOR KEY (KEYBOARD VERSION)---------------------
no_wait:        mov     ah,01
		int     16H
		jnz     k_wait
		xor     ax,ax
		mov     bx,[bp+14]              ;keycode=0
		mov     [bx],ax
		mov     bx,[bp+12]              ;shift=0
		mov     [bx],ax
		jmp     ki_qkey
got_key:        cmp     al,0
		jz      ki_scan
		mov     bx,[bp+14]              ;keycode=ascii
		xor     ah,ah
		mov     [bx],ax
		jmp     short ki_ok
ki_scan:        mov     bx,[bp+14]              ;keycode=scan
		mov     al,ah
		xor     ah,ah
		neg     ax
		mov     [bx],ax

ki_ok:          mov     ah,02                   ;get shift status
		int     16h
		xor     ah,ah
		mov     bx,[bp+12]              ;set SHIFT
		mov     [bx],ax
ki_qkey:        xor     ax,ax
		xor     dx,dx
		jmp     ki_quit

;------------------M O U S E    I N S T A L L E D---------------------
ki_mouse:
		mov     bx,[bp+16]              ;IDKWAIT or IDKNOWAIT
		mov     ah,[bx]                 ; (0)          (1)
		cmp     ah,0
		jnz     ki_mnowait

;------------------WAIT FOR KEY      (MOUSE VERSION)---------------------
ki_mwait:       mov     ah,1                  ;check for mouse/keypress
		int     16H
		jnz     ki_mretval
		call    MouseUp
		cmp     bx,0
		jz      ki_mwait

		push    dx
		push    ax
		mov     ax,bx
		mov     bx,[bp+06]              ;st.mclick
		mov     [bx],ax
		mov     bx,[bp+08]              ;st.mcol
		mov     [bx],di
		mov     bx,[bp+10]              ;st.mrow
		mov     [bx],si

		xor     ax,ax
		mov     bx,[bp+14]              ;keycode=none
		mov     [bx],ax

		mov     ah,02                   ;get shift status
		int     16h
		xor     ah,ah
		mov     bx,[bp+12]              ;set SHIFT
		mov     [bx],ax

		pop     ax
		pop     dx
		jmp     ki_quit

;------------------DONT WAIT FOR KEY (MOUSE VERSION)---------------------
ki_mnowait:     mov     ah,1
		int     16h
		jz      ki_mno

ki_mretval:     mov     ah,00
		int     16h
		jmp     ki_m99
ki_mno:         xor     ax,ax
ki_m99:         cmp     al,0
		jz      ki_mscan
		mov     bx,[bp+14]              ;keycode=ascii
		xor     ah,ah
		mov     [bx],ax
		jmp     short ki_mok
ki_mscan:       mov     bx,[bp+14]              ;keycode=scan
		mov     al,ah
		xor     ah,ah
		neg     ax
		mov     [bx],ax

ki_mok:         mov     ah,02                   ;get shift status
		int     16h
		xor     ah,ah
		mov     bx,[bp+12]              ;set SHIFT
		mov     [bx],ax
		call    MouseUp
		push    dx
		push    ax
		mov     ax,bx
		mov     bx,[bp+06]              ;st.mclick
		mov     [bx],ax
		mov     bx,[bp+08]              ;st.mcol
		mov     [bx],di
		mov     bx,[bp+10]              ;st.mrow
		mov     [bx],si
		pop     ax
		pop     dx
		jmp     ki_quit

ki_quit:
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     12                      ;return 2xParameters
	KbdInt16        endp

;---------------------------------------------------------------------------
; KbdClear
;---------------------------------------------------------------------------
	KbdClear        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    es

		xor     bx,bx
		mov     es,bx
		mov     di,41Ah
		mov     ax,1Eh

		cli     
		stosw
		stosw
		sti

		pop     es
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret                             ;return 2xParameters
	KbdClear        endp

;---------------------------------------------------------------------------
; TSEGADD: Returns address of TYPE variable.
;---------------------------------------------------------------------------
	TSEGADD         proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		mov     bx,[bp+06]              ;get pointer to TYPE

		push    ds                      ;assume TYPEVAR segment
		pop     dx                      ;equals DS
		mov     ax,bx                   ;offset into ax

		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     2                       ;return 2xParameters
	TSEGADD         endp

;---------------------------------------------------------------------------
; MemCpy: Copies content of one memory location to another.
;---------------------------------------------------------------------------
	MemCopy         proc    far

		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    es
		push    di

		mov     bx,[bp+06]              ;get counter
		mov     cx,[bx]

		mov     bx,[bp+08]              ;get destination
		mov     di,[bx]
		mov     es,[bx+02]

		mov     bx,[bp+10]              ;get source
		mov     si,[bx]
		mov     ds,[bx+02]                

		repz    movsb

		pop     di
		pop     es
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret     6                       ;return 2xParameters
	MemCopy         endp

	code    ends
		end

