	Name    SYS_F

	Public  DosPrtErr,DosDiskValid,DosSetDisk,DosCurDisk
	Public  DosDiskType,DosDiskParam
	Public  DosVersion,DosDiskSpace,DosQueryIntel

	Title   SYS_F.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        900311
;***************************************************************************

	extrn   STRINGADDRESS:far
	extrn   STRINGLENGTH:far

;***************************************************************************
;       Data Area
;***************************************************************************
	data    segment word    public  'data'

	sectordata      db      512 dup (?)
	current         db      ?

	dos4            dd      1
			dw      0
			dw      1
			dw      ?
			dw      ?

	strOff  dw      ?               ;string offset  BC7
	strSeg  dw      ?               ;string segment BC7
	StrLen  dw      ?               ;string length  BC7
	data    ends

	dgroup  group   data
;***************************************************************************
;       Code Area
;***************************************************************************
	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

;---------------------------------------------------------------------------
;  DosDiskValid
;---------------------------------------------------------------------------
	DosDiskValid       proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di

		mov     ah,19h                  ;get current drive
		int     21h
		mov     current,al              ;save

		mov     bx,[bp+06]              ;get drive
		mov     dl,[bx]
		mov     cl,dl

		mov     ah,0eh                  ;make the new drive current
		int     21h

		mov     ah,19h                  ;get drive # of new drive
		int     21h
		mov     ch,al                   ;save in cl

		mov     dl,current              ;restore original default
		mov     ah,0eh                  ;make it default again
		int     21h

		mov     ax,1                    ;are true
		cmp     cl,ch                   ;compare old vs. new
		jnz     not_true                ;drive does not exist
		jmp     exit_this

not_true:       xor     ax,ax
exit_this:      pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters
	DosDiskValid       endp

;----------------------------------------------------------------------------
;  DosSetDisk
;----------------------------------------------------------------------------
	DosSetDisk   proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di

		mov     bx,[bp+06]              ;get drive
		mov     dl,[bx]

		push    dx
		xor     ax,ax
		mov     al,dl
		lea     bx,sectordata
		mov     cx,1
		mov     dx,1
		int     25h
		jc      dr_error
		popf
		pop     dx
		mov     ah,0eh                  ;call setdisk
		int     21h
		mov     ax,1
		jmp     dr_exit

dr_error:       popf
		pop     dx
		push    ax
		mov     ah,30h
		int     21h
		cmp     al,4
		jge     dr_400
		pop     ax
		xor     ax,ax
		jmp     short dr_exit

dr_400:         pop     ax
		cmp     ax,0207H
		jnz     dr_400e
		mov     ah,0eh                  ;call setdisk
		int     21h
		mov     ax,1
		jmp     short dr_exit

dr_400e:        xor     ax,ax

dr_exit:        pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters

	DosSetDisk   endp

;----------------------------------------------------------------------------
; DosCurDisk
;----------------------------------------------------------------------------
	DosCurDisk     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di

		mov     ah,19h                  ;call current disk
		int     21h
		xor     ah,ah                   ;clear ah

		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret                             ;return 2xParameters
	DosCurDisk     endp

;----------------------------------------------------------------------------
; DosDiskType
;----------------------------------------------------------------------------
	DosDiskType    proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di

		mov     bx,[bp+06]              ;get drive
		mov     bl,[bx]


		mov     ah,44h                  ;call IOCTL
		mov     al,08h                  ;removable ?
		int     21h
		jc      dt_error                ;error ?
		inc     ax
		xor     ah,ah                   ;clear ah
		jmp     dt_exit

dt_error:       xor     ax,ax

dt_exit:        pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters
	DosDiskType    endp

;----------------------------------------------------------------------------
; DosDiskParam
;----------------------------------------------------------------------------
	DosDiskParam    proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di

		mov     bx,[bp+06]              ;get drive
		mov     dl,[bx]

		mov     ah,08h                  ;call IOCTL
		int     13h
		jc      dp_error                ;error ?
		xor     ax,ax
		mov     al,bl
		jmp     dp_exit

dp_error:       xor     ax,ax

dp_exit:        pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters
	DosDiskParam    endp

;----------------------------------------------------------------------------
; DosVersion
;----------------------------------------------------------------------------
	DosVersion           proc    far

		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di

		mov     ah,30h                  ;get DOS version
		int     21h

		mov     bx,[bp+06]              ;return minor and major
		mov     [bx],ah
		mov     bx,[bp+08]
		mov     [bx],al

		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     4                       ;return 2xParameters

	DosVersion           endp

;----------------------------------------------------------------------------
; DosDiskInfo
;----------------------------------------------------------------------------
	DosDiskSpace    proc    far

		xor     ax,ax
		ret     06

		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di

		mov     bx,[bp+10]              ;get drive number
		mov     dl,[bx]
		mov     ah,36h                  ;call driveinfo
		int     21h
		push    ax                      ;save ax for variable
		mov     si,bx                   ;save bx
		mov     bx,[bp+06]
		mov     [bx],ax                 ;return sectors/cluster
		mov     bx,[bp+08]
		mov     [bx],cx                 ;byte/sector
		mov     bx,[bp+10]
		mov     [bx],dx                 ;clusters/drive
		mov     bx,[bp+12]
		mov     [bx],si                 ;free clusters
		pop     ax
		cmp     ax,-1                   ;if drive invalid
		jz      space_error             ;yes set er=FALSE
		mov     ax,1                    ; else er=TRUE
		jmp     short space_quit
space_error:    mov     ax,0                    ;there is error
space_quit:     pop     di                      ;return to caller
		pop     si
		pop     bp
		ret     06                      ;return 2xParameters

	DosDiskSpace    endp


;----------------------------------------------------------------------------
; DosQueryIntel
;----------------------------------------------------------------------------
	DosQueryIntel   proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    ds
		push    si
		push    di

		pushf
		xor     ax,ax                   ;check for 808X
		push    ax
		popf
		pushf
		pop     ax
		and     ax,0f000h
		cmp     ax,0f000h
		je      i_8x
		push    sp                      ;check for 8018X
		pop     bx
		cmp     bx,sp
		jne     i_18x
		mov     ax,0f000h               ;check for 80286
		push    ax
		popf
		pushf
		pop     ax
		and     ax,0f000h
		je      i_286
		mov     ax,03                   ;it's a 80386
		jmp     processor_return
i_286:          mov     ax,02
		jmp     processor_return
i_18x:          mov     ax,01
		jmp     processor_return
i_8x:           mov     ax,00
processor_return:
		popf                            ;restore flags

		pop     di
		pop     si
		pop     ds
		pop     bp                      ;restore old BP
		ret                             ;return 2xParameters
	DosQueryIntel   endp

;----------------------------------------------------------------------------
; DosPrtErr
;----------------------------------------------------------------------------
	DosPrtErr      proc    far

		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    es

		mov     bx,[bp+08]              ;get port number
		mov     dx,[bx]
		dec     dx
		mov     ah,2
		int     17h                     ; Get printer status
		cmp     ah,90h                  ; Printer hooked up & OK?
		jne     ps2
		xor     ax,ax
		jmp     short prt_exit
ps2:
		CMP   AH,18H                    ; Hooked up, off-line
		JNE   PS3
		MOV   AX,1
		JMP   SHORT prt_EXIT
PS3:
		CMP   AH,0F8H                   ; Hooked up, turned off
		JNE   PS4
		MOV   AX,2
		JMP   SHORT prt_EXIT
PS4:
		CMP   AH,0B0H                   ; Not hooked up/out of paper
		JNE   PS5
		MOV   AX,3
		JMP   SHORT prt_EXIT
PS5:
		MOV   AX,255                    ; Huh?

prt_EXIT:
		mov     ah,0
		pop     es
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     02                      ;return 2xParameters

	DosPrtErr      endp

	code    ends
		end


