	Name    VIO_F

	Public  VioPrint,VioCPrint,VioFrame,VioQueryColor,VioQueryCurSize
	Public  VioGetWindow,VioPutWindow,VioFill,VioShade

	Title   VIO_F.ASM
;***************************************************************************
;       FAR VERSION OF MODULE                                        910324
;***************************************************************************

	extrn   STRINGADDRESS:far
	extrn   STRINGLENGTH:far

;***************************************************************************
;       Data Area
;***************************************************************************

	data    segment word    public  'data'

	fad             db 0

	adapter         db 0
	Video_Buffer    dw ?
	Video_Off       dw ?
	Attribute       db ?

	Row1            db ?
	Col1            db ?
	Row2            db ?
	Col2            db ?

	Frame           db ?
	Rows            db ?
	Stringlen       db ?
	Advance         db 160
	Datastr         db 80 dup (?)

	FrameUL         db ?
	FrameUR         db ?
	FrameLL         db ?
	FrameLR         db ?
	FrameV          db ?
	FrameH          db ?

	column_count    dw ?

	strOff  dw      ?               ;string offset  BC7
	strSeg  dw      ?               ;string segment BC7
	StrLen  dw      ?               ;string length  BC7

	data    ends
	dgroup  group   data


;***************************************************************************
;       Code Area
;***************************************************************************

	code    segment byte    public  'code'
		assume  cs:code,ds:dgroup

;***************************************************************************
; VideoAdapter
;***************************************************************************
	VideoAdapter    proc    far
		mov     ax,1a00h                ;Try to get display
		int     10h                     ;combination code.
		cmp     al,1ah                  ; did it work
		jne     no_psvideo              ; no, check for EGA
		cmp     bl,00h
		jle     no_display              ;no display
		cmp     bl,01h
		jle     mda_display             ;mono
		cmp     bl,03h
		jle     cga_display             ;color graphics
		cmp     bl,05h
		jle     ega_display             ;enhanced graphics
		cmp     bl,06h
		jz      pga_display             ;professional graphics
		cmp     bl,08h
		jle     vga_display             ;VGA
		cmp     bl,0Ch
		jle     mcga_display            ;MCA
		jmp     no_display

no_psvideo:     mov     ah,12h                  ;return EGA info
		mov     bl,10h
		int     10h

		cmp     bl,10h
		jz      mda_or_cga
		jmp     ega_display

mda_or_cga:     mov     ax,40h                  ;Get adapter
		push    ax
		pop     es
		mov     al,es:[10h]
		and     al,110000b
		cmp     al,30h
		je      mda_display             ;It is MDA
		jmp     cga_display

no_display:     mov     ax,-1
		jmp     found_xadapter
mda_display:    mov     dl,0bah
		in      al,dx
		and     al,80h
		mov     ah,al
		mov     cx,8000h
herc1:          in      al,dx
		and     al,80h
		cmp     ah,al
		loope   herc1
		jne     hga_display
		mov     ax,00
		jmp     found_xadapter
cga_display:    mov     ax,01
		jmp     found_xadapter
ega_display:    mov     ax,02
		jmp     found_xadapter
pga_display:    mov     ax,03
		jmp     found_xadapter
mcga_display:   mov     ax,04
		jmp     found_xadapter
vga_display:    mov     ax,05
		jmp     found_xadapter
hga_display:    mov     ax,100
found_xadapter: ret
	VideoAdapter    endp

;***************************************************************************
; video_pos
;***************************************************************************
	video_pos       Proc    Near
		mov     al,160                  ;calculate
		mul     ch                      ;position in
		rol     cl,01
		xor     ch,ch
		add     ax,cx
		mov     Video_Off,ax            ;save videomempos
		call    Find_Adapter            ;get videoadapter
		ret
	video_pos       Endp

;***************************************************************************
; Find_Adapter finds videoadapter.
;***************************************************************************
	Find_Adapter    Proc    Near
		push    ax
		push    bx
		push    dx
		push    es
		mov     ah,fad
		cmp     ah,1
		jz      find_ad_2
		mov     ah,1
		mov     fad,ah
		mov     ax,40h                  ;Get adapter and
		push    ax                      ;Videobuffer address
		pop     es
		mov     dl,1
		mov     bx,0b000h
		mov     al,es:[10h]
		and     al,110000b
		cmp     al,30h
		je      found_adapter
		add     bx,800h
		inc     dl
		mov     al,es:[87h]
		cmp     al,0
		je      found_adapter
		inc     dl
found_adapter:  mov     Video_Buffer,bx
		mov     Adapter,dl
find_ad_2:      pop     es
		pop     dx
		pop     bx
		pop     ax
		ret
	Find_Adapter    Endp

;***************************************************************************
; Output_cell
;***************************************************************************
	Output_Cell     Proc    Near
		mov     es,Video_Buffer
		mov     ah,Attribute
		mov     di,Video_Off
		mov     dx,03dah
		push    ds
		push    si
		mov     si,strOff
		mov     ds,strSeg
		cld
oc_Output1:     cmp     Adapter,2
		jne     oc_Output2
oc_No_Retrace:  in      al,dx
		test    al,1
		jne     oc_No_Retrace
oc_Retrace:     in      al,dx
		test    al,1
		je      oc_Retrace
oc_Output2:     lodsb
		stosw
		loop    oc_Output1
		pop     si
		pop     ds
		ret
	Output_Cell     Endp

;***************************************************************************
; Output_Attr
;***************************************************************************
	Output_Attr     Proc    Near
		mov     ah,Attribute
		mov     di,Video_Off
		inc     di
		mov     es,Video_Buffer
		mov     dx,03dah
		cld
oa_Output1:     cmp     Adapter,2
		jne     oa_Output2
oa_No_Retrace:  in      al,dx
		test    al,1
		jne     oa_No_Retrace
oa_Retrace:     in      al,dx
		test    al,1
		je      oa_Retrace
oa_Output2:     mov     es:[di],ah
		inc     di
		inc     di
		loop    oa_Output1
		ret
	Output_Attr     Endp

;***************************************************************************
; Output_String moves string to display buffer.
;***************************************************************************
	Output_String   Proc    Near
		mov     es,Video_Buffer
		mov     di,Video_Off
		mov     dx,03dah
		push    ds
		push    si
		mov     si,strOff
		mov     ds,strSeg
		cld
Output1:        cmp     Adapter,2
		jne     Output2
No_Retrace:     in      al,dx
		test    al,1
		jne     No_Retrace
Retrace:        in      al,dx
		test    al,1
		je      Retrace
Output2:        lodsb
		stosb
		inc     di
		loop    Output1
		pop     si
		pop     ds
		ret
	Output_String   Endp

;***************************************************************************
; Input_word
;***************************************************************************
	Input_Word      Proc    Near
		push    ds
		push    es
		mov     es,strSeg
		mov     si,Video_Off
		mov     dx,03dah
		mov     ds,Video_Buffer
		cld
iw_Output1:     cmp     Adapter,2
		jne     iw_Output2
iw_No_Retrace:  in      al,dx
		test    al,1
		jne     iw_No_Retrace
iw_Retrace:     in      al,dx
		test    al,1
		je      iw_Retrace
iw_Output2:     lodsw
		stosw
		loop    iw_Output1
		pop     es
		pop     ds
		ret
	Input_Word      Endp

;***************************************************************************
; Output_word
;***************************************************************************
	Output_Word     Proc    Near
		mov     es,Video_Buffer
		mov     di,Video_Off
		mov     dx,03dah
		push    ds
		mov     ds,strSeg
		cld
ow_Output1:     cmp     Adapter,2
		jne     ow_Output2
ow_No_Retrace:  in      al,dx
		test    al,1
		jne     ow_No_Retrace
ow_Retrace:     in      al,dx
		test    al,1
		je      ow_Retrace
ow_Output2:     lodsw
		stosw
		loop    ow_Output1
		pop     ds
		ret
	Output_Word     Endp

;***************************************************************************
; Vertical_Frame writes vertical frame.
;***************************************************************************
	Vertical_Frame  Proc    Near
		cmp     dl,1
		jnz     Frame_Good
		mov     al,FrameLL
		mov     FrameUL,al
		mov     al,FrameLR
		mov     FrameUR,al

Frame_Good:     mov     si,offset dgroup:DataStr
		mov     al,FrameUL
		mov     [si],al
		mov     ah,Stringlen
		dec     ah
		dec     ah

		xor     cx,cx
		mov     cl,ah
Frame_Two:      mov     al,FrameV
		inc     si
		mov     [si],al
		loop    Frame_Two
		mov     ah,FrameUR
		inc     si
		mov     [si],ah

		mov     si,offset dgroup:DataStr
		xor     cx,cx
		mov     cl,Stringlen
		mov     strOff,si               ;to use far string
		mov     strSeg,dgroup           ;with Output_cell

		call    Output_Cell                     ;print UL char
		ret
	Vertical_Frame  Endp

;----------------------------------------------------------------------------
; VioPrint
;----------------------------------------------------------------------------
	VioPrint           proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    es

		mov     bx,[bp+10]              ;get y-pos
		mov     ch,[bx]
		dec     ch

		mov     bx,[bp+08]              ;get x-pos
		mov     cl,[bx]
		dec     cl

		call    video_pos

		mov     ax,[bp+06]              ;get string address
		push    ax                      ;and length
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx
		mov     ax,[bp+06]
		push    ax
		call    STRINGLENGTH
		mov     cx,ax

		cmp     cx,0                    ;if string=0 dont
		jz      swcs_ready              ;bother

		call    Output_String           ;write string

swcs_ready:     pop     es
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     6                       ;return 2xParameters
	VioPrint           endp

;----------------------------------------------------------------------------
; VioCPrint
;----------------------------------------------------------------------------
	VioCPrint         proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    es

		mov     bx,[bp+08]              ;get attribute
		mov     dh,[bx]

		mov     Attribute,dh

		mov     bx,[bp+10]              ;get x-pos
		mov     cl,[bx]
		dec     cl

		mov     bx,[bp+12]              ;get y-pos
		mov     ch,[bx]
		dec     ch

		call    video_pos

		mov     ax,[bp+06]              ;get string address
		push    ax                      ;and length
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx
		mov     ax,[bp+06]
		push    ax
		call    STRINGLENGTH
		mov     cx,ax

		cmp     cx,0                    ;if string=0 dont
		jz      swas_ready              ;bother

		call    Output_Cell             ;write string

swas_ready:     pop     es
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     8                       ;return 2xParameters
	VioCPrint         endp

;----------------------------------------------------------------------------
; VioFrame
;----------------------------------------------------------------------------
	VioFrame     proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    es

		mov     bx,[bp+06]              ;get frame character
		mov     ah,[bx]
		mov     Frame,ah

		mov     bx,[bp+08]              ;get attribute
		mov     dh,[bx]
		mov     Attribute,dh

		mov     bx,[bp+16]              ;get Row1-pos
		mov     cl,[bx]
		dec     cl
		mov     Row1,cl

		mov     bx,[bp+14]              ;get Col1-pos
		mov     ch,[bx]
		dec     ch
		mov     Col1,ch

		mov     bx,[bp+12]              ;get Row2-pos
		mov     cl,[bx]
		dec     cl
		mov     Row2,cl

		mov     bx,[bp+10]              ;get Col2-pos
		mov     ch,[bx]
		dec     ch
		mov     Col2,ch

		mov     al,Col2                 ;Get string length
		mov     bl,Col1                 ;(col2-col1)
		sub     al,bl
		inc     al
		mov     Stringlen,al

		mov     si,offset dgroup:Datastr
						;fill string with ' '
		mov     cx,80
		mov     al,' '
WrtFr_One:      mov     [si],al
		inc     si
		loop    WrtFr_One

		mov     al,Row2                ;Get rows
		mov     bl,Row1                ;(row2-row1)
		sub     al,bl
		inc     al
		mov     Rows,al

		mov     ah,Frame

		cmp     ah,0                    ;type of frame
		jz      Single_line
		cmp     ah,255
		jz      Double_line

		mov     FrameUL,ah              ;use given character
		mov     FrameUR,ah              ;to draw frame with.
		mov     FrameLL,ah
		mov     FrameLR,ah
		mov     FrameV,ah
		mov     FrameH,ah
		jmp     short Frame_Ok

Single_Line:    mov     FrameUL,''             ;draw frame with single
		mov     FrameUR,''             ;line character.
		mov     FrameLL,''
		mov     FrameLR,''
		mov     FrameV,''
		mov     FrameH,''
		jmp     short Frame_Ok

Double_Line:    mov     FrameUL,''             ;draw frame with double
		mov     FrameUR,''             ;line character.
		mov     FrameLL,''
		mov     FrameLR,''
		mov     FrameV,''
		mov     FrameH,''

Frame_Ok:       mov     ch,Row1
		mov     cl,Col1

		call    video_pos

		xor     bx,bx                   ;set loop counter
		mov     bl,Rows                 ;in BX
		mov     si,offset dgroup:Datastr;
		mov     cl,FrameH
		mov     [si],cl                 ;set FrameH i start and
		xor     ax,ax
		mov     al,Stringlen               ;end of string
		add     si,ax
		dec     si
		mov     [si],cl
		sub     si,ax

loop_str:       xor     cx,cx                   ;set string length
		mov     cl,Stringlen               ;in CX
		mov     si,offset dgroup:Datastr

		mov     strOff,si               ;to use far string
		mov     strSeg,dgroup           ;with Output_cell

		call    Output_Cell             ;write string

		mov     ax,Video_Off            ;set new position
		xor     cx,cx
		mov     cl,Advance
		add     ax,cx                   ;in video memory
		mov     Video_Off,ax

		dec     bx                      ;decrement BX
		cmp     bx,1                    ;and check if ready
		jg      loop_str


Draw_Frame:     mov     ch,Row1
		mov     cl,Col1

		mov     al,160                  ;calculate
		mul     ch                      ;position in
		rol     cl,01                   ;videomemory
		xor     ch,ch
		add     ax,cx
		mov     Video_Off,ax         ;save videomempos

		mov     dl,0
		call    Vertical_Frame

		xor     bx,bx                   ;set loop counter
		mov     bl,Rows                 ;in BX

Frame_Three:    mov     ax,Video_Off         ;set new position
		xor     cx,cx
		mov     cl,Advance
		add     ax,cx                   ;in video memory
		mov     Video_Off,ax

		dec     bx                      ;decrement BX
		cmp     bx,1                    ;and check if ready
		jg      Frame_Three

		mov     dl,1
		call    Vertical_Frame

		pop     es
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     12                      ;return 2xParameters
	VioFrame     endp

;----------------------------------------------------------------------------
; VioGetWindow
;----------------------------------------------------------------------------
	VioGetWindow           proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     bx,[bp+14]              ;set y-pos1
		mov     dh,[bx]
		dec     dh
		mov     Row1,dh

		mov     bx,[bp+12]              ;get x-pos1
		mov     dl,[bx]
		dec     dl
		mov     Col1,dl

		mov     bx,[bp+10]              ;get y-pos2
		mov     cl,[bx]
		dec     cl
		mov     Row2,cl

		mov     bx,[bp+08]              ;get x-pos2
		mov     ch,[bx]
		dec     ch
		mov     Col2,ch

		mov     al,Col2                 ;Get string length
		mov     bl,Col1                 ;(col2-col1)
		sub     al,bl
		inc     al
		mov     Stringlen,al

		mov     al,Row2                ;Get rows
		mov     bl,Row1                ;(row2-row1)
		sub     al,bl
		inc     al
		mov     Rows,al

		mov     ax,[bp+06]              ;get string address
		push    ax                      ;and length
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx

		mov     ch,Row1                 ;Get first video
		mov     cl,Col1                 ;memory position
		call    video_pos

		xor     bx,bx                   ;set loop counter
		mov     bl,Rows                 ;in BX

		push    ds                      ;string in es
		pop     es

		mov     di,strOff               ;set di to stringstart
loop_get:       xor     cx,cx                   ;set string length
		mov     cl,Stringlen            ;in CX
		call    Input_Word              ;get string

		mov     ax,Video_Off            ;set new position
		xor     cx,cx
		mov     cl,Advance
		add     ax,cx                   ;in video memory
		mov     Video_Off,ax

		dec     bx                      ;decrement BX
		cmp     bx,0                    ;and check if ready
		jg      loop_get

		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     10                      ;return 2xParameters
	VioGetWindow           endp

;----------------------------------------------------------------------------
; VioPutWindow
;----------------------------------------------------------------------------
	VioPutWindow           proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     bx,[bp+14]              ;set y-pos1
		mov     dh,[bx]
		dec     dh
		mov     Row1,dh

		mov     bx,[bp+12]              ;get x-pos1
		mov     dl,[bx]
		dec     dl
		mov     Col1,dl

		mov     bx,[bp+10]              ;get y-pos2
		mov     cl,[bx]
		dec     cl
		mov     Row2,cl

		mov     bx,[bp+08]              ;get x-pos2
		mov     ch,[bx]
		dec     ch
		mov     Col2,ch

		mov     al,Col2                 ;Get string length
		mov     bl,Col1                 ;(col2-col1)
		sub     al,bl
		inc     al
		mov     Stringlen,al

		mov     al,Row2                ;Get rows
		mov     bl,Row1                ;(row2-row1)
		sub     al,bl
		inc     al
		mov     Rows,al

		mov     ax,[bp+06]              ;get string address
		push    ax                      ;and length
		call    STRINGADDRESS
		mov     strOff,ax
		mov     strSeg,dx

		mov     ch,Row1                 ;Get first video
		mov     cl,Col1                 ;memory position
		call    video_pos

		xor     bx,bx                   ;set loop counter
		mov     bl,Rows                 ;in BX

		mov     si,strOff
loop_put:       xor     cx,cx                   ;set string length
		mov     cl,Stringlen            ;in CX
		call    Output_Word             ;get string

		mov     ax,Video_Off            ;set new position
		xor     cx,cx
		mov     cl,Advance
		add     ax,cx                   ;in video memory
		mov     Video_Off,ax

		dec     bx                      ;decrement BX
		cmp     bx,0                    ;and check if ready
		jg      loop_put

		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     10                      ;return 2xParameters
	VioPutWindow           endp

;----------------------------------------------------------------------------
; VioShade
;----------------------------------------------------------------------------
	VioShade        proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    ds
		push    es

		mov     bx,[bp+12]              ;set y-pos1
		mov     dh,[bx]
		mov     Row1,dh

		mov     bx,[bp+10]              ;get x-pos1
		mov     dl,[bx]
		inc     dl
		mov     Col1,dl

		mov     bx,[bp+08]              ;get y-pos2
		mov     cl,[bx]
		dec     cl
		mov     Row2,cl

		mov     bx,[bp+06]              ;get x-pos2
		mov     ch,[bx]
		dec     ch
		mov     Col2,ch

		mov     al,Col2                 ;Get string length
		mov     bl,Col1                 ;(col2-col1)
		sub     al,bl
		inc     al
		mov     Stringlen,al

		mov     al,Row2                ;Get rows
		mov     bl,Row1                ;(row2-row1)
		sub     al,bl
		inc     al
		mov     Rows,al

		mov     ch,Row1                 ;Get first video
		mov     cl,Col1                 ;memory position
		call    video_pos

		xor     bx,bx                   ;set loop counter
		mov     bl,Rows                 ;in BX

		mov     ah,8                    ;set attribute to
		mov     Attribute,ah            ;GRAY on BLACK

loop_shade:     xor     cx,cx                   ;set string length
		mov     cl,Stringlen            ;in CX
		call    Output_Attr             ;output attribute string

		mov     ax,Video_Off            ;set new position
		xor     cx,cx
		mov     cl,Advance
		add     ax,cx                   ;in video memory
		mov     Video_Off,ax

		dec     bx                      ;decrement BX
		cmp     bx,0                    ;and check if ready
		jg      loop_shade

		pop     es
		pop     ds
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret      8                      ;return 2xParameters
	VioShade        endp

;----------------------------------------------------------------------------
; VioFill
;----------------------------------------------------------------------------
	VioFill      proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    es

		mov     bx,[bp+08]              ;get attribute
		mov     dh,[bx]
		mov     Attribute,dh

		mov     bx,[bp+10]              ;get x-pos
		mov     cl,[bx]
		dec     cl

		mov     bx,[bp+12]              ;get y-pos
		mov     ch,[bx]
		dec     ch

		call    video_pos

		mov     bx,[bp+06]              ;get length
		mov     cx,[bx]

		cmp     cx,0                    ;if string=0 dont
		jz      swa_ready               ;bother

		call    Output_Attr             ;write string

swa_ready:      pop     es
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     8                       ;return 2xParameters
	VioFill      endp

;----------------------------------------------------------------------------
; VioQueryColor
;----------------------------------------------------------------------------
	VioQueryColor   proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    es

		push    ds                      ;save data segment
		xor     dx,dx                   ;clear DX
		push    dx                      ;DS=0000h
		pop     ds
		mov     bx,0463h                ;BX points to 0463H that
		mov     ch,[bx]                 ;contains color/mono info
		pop     ds                      ;return DS
		cmp     ch,0b4h                 ;if it is B4h then mono
		jz      no_color                ;jump no color
		mov     cx,1                    ;set IS_COLOR
		jmp     short color_cont        ;ok, continue
no_color:       xor     cx,cx                   ;set mono

color_cont:     push    cx                      ;save color info
		call    VideoAdapter            ;get video adapter
						;returned in AX
		pop     cx                      ;retrieve color info

		mov     bx,[bp+06]              ;return videoadapter
		mov     [bx],ax
		mov     ax,cx                   ;return color info

		pop     es
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     2                       ;return 2xParameters
	VioQueryColor   endp

;----------------------------------------------------------------------------
; VioQueryCurSize
;----------------------------------------------------------------------------
	VioQueryCurSize proc    far
		push    bp                      ;save old BP
		mov     bp,sp                   ;address of parameters in BP
		push    si
		push    di
		push    es

		mov     bh,0
		mov     ah,3
		int     10h

		push    cx

		xor     ch,ch
		mov     bx,[bp+06]              ;return lower scan line
		mov     [bx],cx

		pop     cx

		mov     cl,ch
		xor     ch,ch
		mov     bx,[bp+08]              ;return upper scan line
		mov     [bx],cx

		pop     es
		pop     di
		pop     si
		pop     bp                      ;restore old BP
		ret     4                       ;return 2xParameters

	VioQueryCurSize endp

	code    ends
		end

