DECLARE FUNCTION FileBoxOpen% (wild$, path$, file$)
DECLARE FUNCTION FileBoxSaveAs% (file$, ext$, path$)
DECLARE SUB FBGetDir (path$)
DECLARE SUB FBGetDrvPath (iDrive%, sPath$)
REM     *********************************************************************
REM     * FILEBOX.MOD
REM     *********************************************************************
REM     * FUNCTION FileBoxOpen%
REM     * FUNCTION FileBoxSaveAs%
REM     *
REM     *********************************************************************
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 900703: Rewritten
REM     *--------------------------------------------------------------------
REM     * 900704: Mouse support added.
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

	REDIM SHARED fdir$(1), ddir$(1), disk$(1)

'       ---------------------------------------------------------------------
'        FBGetDir:
'       ---------------------------------------------------------------------
	SUB FBGetDir (path$)
		STATIC drvtable

		antal = DosQMatches(path$ + CHR$(0), IDFANORMAL)
		REDIM tdir(antal)  AS DIRENTRYTYPE
		REDIM fdir$(antal)
		CALL DosGetDir(tdir(), path$ + CHR$(0), IDFANORMAL)
		FOR counter = 1 TO antal
		fdir$(counter) = RTRIM$(tdir(counter - 1).fname)
		NEXT counter

		punkt = INSTR(path$, ".")
		temp$ = LEFT$(path$, punkt) + "*"

		IF LEN(temp$) < 7 THEN
		   skip1 = 0
		   skip12 = 1
		ELSE
		   skip1 = 1
		   skip12 = 0
		END IF

		antal = DosQMatches(temp$ + CHR$(0), IDFADIRECTORY)
		REDIM tdir(antal)  AS DIRENTRYTYPE

		IF antal <> 0 THEN
		   REDIM ddir$(antal - skip1)
		   CALL DosGetDir(tdir(), temp$ + CHR$(0), IDFADIRECTORY)
		   FOR counter = 1 TO antal - skip1
		   ddir$(counter) = "[" + RTRIM$(tdir(counter - skip12).fname) + "]"
		   NEXT counter
		ELSE
		   REDIM ddir$(0)
		END IF

		IF drvtable = FALSE THEN
		   antal = 0
		   REDIM temp$(25)
		   FOR counter = 0 TO 25
		   IF DosDiskValid(counter) = TRUE THEN
		      IF counter = 1 THEN
			 DEF SEG = &H40
			 drv = PEEK(&H10)
			 IF (drv AND 64) = 64 THEN
			    antal = antal + 1
			    temp$(antal) = CHR$(65 + counter)
			 END IF
			 DEF SEG
		      ELSE
			 antal = antal + 1
			 temp$(antal) = CHR$(65 + counter)
		      END IF
		   END IF
		   NEXT counter
		   REDIM disk$(antal)
		   FOR counter = 1 TO antal
		   disk$(counter) = "[-" + temp$(counter) + "-]"
		   NEXT counter
		   drvtable = TRUE
		END IF
	END SUB

'       ---------------------------------------------------------------------
'        FBGetDrvPath:
'       ---------------------------------------------------------------------
	SUB FBGetDrvPath (iDrive, sPath$)
	    iDrive = DosCurDisk
	    sPath$ = CURDIR$
	END SUB

'       ---------------------------------------------------------------------
'        FileBoxOpen:
'       ---------------------------------------------------------------------
	FUNCTION FileBoxOpen (wild$, path$, file$)
	    CALL FBGetDrvPath(olddrv, oldpath$)
	    cpath$ = oldpath$

	    DIM hwnd AS WINDOWTYPE

	    sVio$ = WinOpenWindow(hwnd, 5, 18, 15, 40, "Open File", -1, -1, -1)

	    CALL WinPrint(hwnd, 13, 2, STRING$(40 - 3, 196))
	    CALL WinPrint(hwnd, 14, 7, "Enter=Select    Esc=Cancel")

	    startat = 1
	    fieldid = 1

	    quit = FALSE
	    DO
	       IF LEN(cpath$) < 4 THEN
		  temp$ = cpath$ + wild$
	       ELSE
		  temp$ = cpath$ + "\" + wild$
	       END IF

	       CALL FBGetDir(temp$)
	       CALL WinPrint(hwnd, 2, 2, SPACE$(36))

	       temp$ = LEFT$(temp$, 38)
	       CALL WinPrint(hwnd, 2, 2, temp$)

	       temp = UBOUND(fdir$) + UBOUND(ddir$) + UBOUND(disk$)
	       REDIM temp$(temp)
	       FOR counter = 1 TO UBOUND(fdir$)
		   temp$(counter) = fdir$(counter)
	       NEXT counter
	       temp = counter
	       FOR counter = temp TO temp + UBOUND(ddir$) - 1
		   temp$(counter) = ddir$(counter - temp + 1)
	       NEXT counter
	       temp = counter
	       FOR counter = temp TO temp + UBOUND(disk$) - 1
		   temp$(counter) = disk$(counter - temp + 1)
	       NEXT counter

	       DIM li AS LISTBOXTYPE
	       DIM tli AS LISTBOXTYPE
	       li = tli

	       li.row1 = 4
	       li.col1 = 2
	       li.row2 = 7
	       li.col2 = 36
	       li.frame = TRUE

	       void = WinListBox(hwnd, li, 0, temp$())
	       quitlb = FALSE
	       DO
		  ret = WinListBox(hwnd, li, 1, temp$())
		  SELECT CASE ret
			 CASE KEYENTER, KEYESC
			      up = li.curpos
			      quitlb = TRUE
			 CASE ELSE
		  END SELECT
	       LOOP WHILE quitlb = FALSE
	       void = WinListBox(hwnd, li, 2, temp$())

	       SELECT CASE ret
		      CASE KEYENTER
			   IF ASC(temp$(up)) <> 91 THEN
			      path$ = cpath$
			      file$ = RTRIM$(temp$(up))
			      FileBoxOpen = TRUE
			      quit = TRUE
			   ELSE
			      IF LEFT$(temp$(up), 2) = "[-" THEN
				 temp = ASC(MID$(temp$(up), 3, 1)) - 65
				 IF DosSetDisk(temp) = FALSE THEN
				    BEEP
				 ELSE
				    CALL FBGetDrvPath(temp, cpath$)
				 END IF
			      ELSE
				 temp$ = RTRIM$(MID$(temp$(up), 2, LEN(temp$(up)) - 2))
				 IF DosChangeDir(temp$ + CHR$(0)) = FALSE THEN
				    BEEP
				 ELSE
				    CALL FBGetDrvPath(temp, cpath$)
				 END IF
			      END IF
			   END IF
		      CASE KEYESC
			   FileBoxOpen = FALSE
			   quit = TRUE
		      CASE ELSE
	       END SELECT
	    LOOP WHILE quit = FALSE
	    CALL WinCloseWindow(hwnd, sVio$)
	    void = DosSetDisk(olddrv)
	    void = DosChangeDir(oldpath$ + CHR$(0))
	END FUNCTION

'       ---------------------------------------------------------------------
'        FileBoxSaveAs:
'       ---------------------------------------------------------------------
	FUNCTION FileBoxSaveAs (file$, ext$, path$)
	    CALL FBGetDrvPath(olddrv, oldpath$)
	    cpath$ = oldpath$

	    IF INSTR(ext$, ".") = FALSE THEN
	       ext$ = "." + ext$
	    END IF

	    DIM hwnd AS WINDOWTYPE

	    sVio$ = WinOpenWindow(hwnd, 6, 20, 15, 40, "Save File As", -1, -1, -1)
		   
	    CALL WinPrint(hwnd, 2, 3, "Filename:")

	    CALL WinPrint(hwnd, 13, 2, STRING$(40 - 3, 196))
	    CALL WinPrint(hwnd, 14, 7, "Enter=Select    Esc=Cancel")

	    CALL WinEditPrint(hwnd, 2, 13, StrFormat$(IDSFSTR, SPACE$(12), file$))

	    iFirst = TRUE

	    startat = 1
	    fieldid = 2

	    quit = FALSE
	    DO
	       IF LEN(cpath$) < 4 THEN
		  temp$ = cpath$ + "*.*"
	       ELSE
		  temp$ = cpath$ + "\*.*"
	       END IF
	       CALL FBGetDir(temp$)

	       CALL WinPrint(hwnd, 4, 1, SPACE$(40))
	       temp$ = LEFT$(temp$, 40)
	       CALL WinPrint(hwnd, 4, 3, temp$)

	       temp = UBOUND(ddir$) + UBOUND(disk$)
	       REDIM temp$(temp)
	       FOR counter = 1 TO UBOUND(ddir$)
		   temp$(counter) = ddir$(counter)
	       NEXT counter

	       temp = counter
	       FOR counter = temp TO temp + UBOUND(disk$) - 1
		   temp$(counter) = disk$(counter - temp + 1)
	       NEXT counter

	       IF iFirst = TRUE THEN
		  iFirst = FALSE
		  DIM li AS LISTBOXTYPE

		  li.row1 = 5
		  li.col1 = 2
		  li.row2 = 7
		  li.col2 = 36
		  li.frame = TRUE

		  void = WinListBox(hwnd, li, 0, temp$())

		  IF UBOUND(temp$) > 6 THEN
		     temp = 6
		  ELSE
		     temp = UBOUND(temp$)
		  END IF
		  FOR counter = 1 TO temp
		      CALL WinPrint(hwnd, counter + 5, 3, temp$(counter))
		  NEXT counter
	       END IF

	       SELECT CASE fieldid
		      CASE 1
			   DIM tli AS LISTBOXTYPE
			   li = tli

			   li.row1 = 5
			   li.col1 = 2
			   li.row2 = 7
			   li.col2 = 36
			   li.frame = TRUE

			   void = WinListBox(hwnd, li, 0, temp$())
			   quitlb = FALSE
			   DO
			      ret = WinListBox(hwnd, li, 1, temp$())
			      SELECT CASE ret
				     CASE KEYENTER, KEYESC, KEYTAB
					  up = li.curpos
					  quitlb = TRUE
				     CASE ELSE
			      END SELECT
			   LOOP WHILE quitlb = FALSE
			   void = WinListBox(hwnd, li, 2, temp$())


			   SELECT CASE ret
				  CASE KEYENTER
				       IF LEFT$(temp$(up), 2) = "[-" THEN
					  temp = ASC(MID$(temp$(up), 3, 1)) - 65
					  IF DosSetDisk(temp) = FALSE THEN
					     BEEP
					  ELSE
					     CALL FBGetDrvPath(temp, cpath$)
					  END IF
				       ELSE
					  temp$ = RTRIM$(MID$(temp$(up), 2, LEN(temp$(up)) - 2))
					  IF DosChangeDir(temp$ + CHR$(0)) = FALSE THEN
					     BEEP
					  ELSE
					     CALL FBGetDrvPath(temp, cpath$)
					  END IF
				       END IF
				  CASE KEYESC
				       FileBoxSaveAs = FALSE
				       quit = TRUE
				  CASE KEYTAB
				       fieldid = 2
				  CASE ELSE
			   END SELECT
		      CASE 2
			   REDIM iRet(3)
				 iRet(1) = KEYENTER
				 iRet(2) = KEYESC
				 iRet(3) = KEYTAB
			   ret = WinEditString(hwnd, file$, 2, 13, 12, iRet(), IDHUCASE)
			   CALL WinEditPrint(hwnd, 2, 13, StrFormat$(IDSFSTR, SPACE$(12), file$))
			   SELECT CASE ret
				  CASE KEYENTER
				       path$ = cpath$
				       IF INSTR(file$, ".") = FALSE THEN
					  file$ = RTRIM$(LEFT$(file$, 8)) + ext$
				       END IF
				       IF DosQFile(path$ + file$ + CHR$(0), IDFCREATE) = TRUE THEN
					  nul = DosKill(path$ + file$ + CHR$(0))
					  FileBoxSaveAs = TRUE
					  quit = TRUE
				       ELSE
					  BEEP
				       END IF
				  CASE KEYESC
				       FileBoxSaveAs = FALSE
				       quit = TRUE
				  CASE KEYTAB
				       fieldid = 1
				  CASE ELSE
			   END SELECT
		      CASE ELSE
	       END SELECT
	    LOOP WHILE quit = FALSE
	    CALL WinCloseWindow(hwnd, sVio$)
	    void = DosSetDisk(olddrv)
	    void = DosChangeDir(oldpath$ + CHR$(0))
	END FUNCTION

