DECLARE FUNCTION FileFind% (sFileList$(), sStartPath$)
DECLARE SUB FFScanDisk (pathspec$)
REM     *********************************************************************
REM     * FILEFIND.MOD
REM     *********************************************************************
REM     * SUB FileFind
REM     *
REM     *********************************************************************
REM     * 880922: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 930610: Fixed and added into STLIB
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

	TYPE SUBDIRTYPE
	     sDirName   AS STRING * 12
	END TYPE

	REM $DYNAMIC
	DEFINT A-Z

	DIM SHARED iMaxFiles, iFiles, iRoof, sWildCard$, sTmpList$()

REM $STATIC
'       --------------------------------------------------------------------
'        FFScanDisk: Scans disk recursive.                    
'       --------------------------------------------------------------------
	SUB FFScanDisk (sCurPath$)
	    IF iFiles < iMaxFiles THEN
	       szTemp$ = sCurPath$ + sWildCard$ + CHR$(0)
	       iAntal = DosQMatches(szTemp$, IDFAFILE)
	       REDIM fileNames(iAntal) AS DIRENTRYTYPE
	       CALL DosGetDir(fileNames(), szTemp$, IDFAFILE)
	       FOR iCounter = 1 TO iAntal
		   IF iFiles < iMaxFiles THEN
		      iFiles = iFiles + 1
		      sTmpList$(iFiles) = sCurPath$ + StrTrim$(fileNames(iCounter - 1).fname)
		   ELSE
		      iRoof = TRUE
		      EXIT FOR
		   END IF
	       NEXT iCounter

	       szTemp$ = sCurPath$ + "*.*" + CHR$(0)
	       iAntal = DosQMatches(szTemp$, IDFADIRECTORY)
	       IF iAntal > 0 THEN
		  REDIM dirNames(iAntal) AS SUBDIRTYPE
		  CALL DosGetSubDir(dirNames(), szTemp$, iAntal)
	       END IF
	    ELSE
	       iRoof = TRUE
	       iAntal = 0
	    END IF

	    FOR iCounter = 1 TO iAntal
		sNextPath$ = sCurPath$ + StrTrim$(dirNames(iCounter).sDirName) + "\"
		CALL FFScanDisk(sNextPath$)
	    NEXT iCounter
	END SUB

'       ---------------------------------------------------------------------
'        FileFind:
'       ---------------------------------------------------------------------
	FUNCTION FileFind (sFileList$(), sStartPath$)
	    sWildCard$ = sFileList$(0)
	    iMaxFiles = UBOUND(sFileList$)
	    iFiles = 0
	    iRoof = FALSE

	    REDIM sTmpList$(iMaxFiles)

	    IF LTRIM$(sStartPath$) = "" THEN
	       sStartPath$ = "\"
	    END IF

	    CALL FFScanDisk(sStartPath$)

	    IF iFiles > 0 THEN
	       FOR iCounter = 1 TO iFiles
		   sFileList$(iCounter) = sTmpList$(iCounter)
		   sTmpList$(iCounter) = ""
	       NEXT
	       REDIM sTmpList$(0)
	       REDIM PRESERVE sFileList$(iFiles)
	       IF iRoof = FALSE THEN
		  FileFind = TRUE
	       ELSE
		  FileFind = FALSE
	       END IF
	    ELSE
	       REDIM sTmpList$(0)
	       REDIM PRESERVE sFileList$(0)
	       FileFind = TRUE
	    END IF
	END FUNCTION

