REM     *********************************************************************
REM     * MDBLIST.MOD
REM     *********************************************************************
REM     * FUNCTION MDBList
REM     *
REM     *********************************************************************
REM     * 900702: Created
REM     *--------------------------------------------------------------------
REM     * 900702: Changed and added to STLIB7
REM     *--------------------------------------------------------------------
REM     * 920419: Changed for new color settings.
REM     *********************************************************************
	REM $INCLUDE: 'STLIB.BI'
	DEFINT A-Z

	'------------------------------------------------------------
	' HOW TO USE !
	'
	' 1) Fill MDBLISTTYPE with wanted values
	' 2) Call with 0, return TRUE=OK, FALSE=no records in file
	'    If FALSE either add record and call again or abort
	' 3) RETRIEVE first record and place in string, call with 1.
	'    Call with RETRIEVEd record until it returns TRUE
	' 4) Loop for keypress with 2. If returns -1 then loop with
	'    1 like in 3). If you want to redraw list call with 2
	'    and "REDRAW" in string.
	' 5) To shut down call with 3
	'------------------------------------------------------------

'       --------------------------------------------------------------------
'        MDBList: Lists a MDB file kind of like ListBox.
'       --------------------------------------------------------------------
	STATIC FUNCTION MDBList (mdbfunc, ml AS MDBLISTTYPE, temp$)
	    SELECT CASE mdbfunc
		   CASE 0
			r1 = ml.row1
			c1 = ml.col1
			r2 = ml.row2
			c2 = ml.col2
			hFile = ml.handle
			IF ml.frame = TRUE THEN
			   CALL VioFrame(r1, c1, r2, c2, VioColor(st.ebcolor, st.efcolor), 0)
			   CALL VioPrint(r1 + 1, c2, CHR$(24))
			   FOR counter = r1 + 2 TO r2 - 2
			       CALL VioPrint(counter, c2, CHR$(177))
			   NEXT counter
			   CALL VioPrint(r2 - 1, c2, CHR$(25))
			   r1 = r1 + 1
			   c1 = c1 + 1
			   r2 = r2 - 1
			   c2 = c2 - 1
			END IF
			llen = r2 - r1 + 1
			vioclr = VioColor(st.efcolor, st.ebcolor)
			CALL VioCPrint(r1, c1, vioclr, SPACE$(c2 - c1 + 1))
			doredraw = TRUE
			counter = 1
			antal = 0
			
			IF LOF(hFile) = 0 THEN
			   MDBList = FALSE
			   EXIT FUNCTION
			END IF
			MOVEFIRST ml.handle
			MDBList = TRUE
			EXIT FUNCTION
		   CASE 1
			IF counter <= llen THEN
			   antal = antal + 1
			   temp$ = LEFT$(temp$, c2 - c1 + 1)
			   CALL VioPrint(r1 - 1 + counter, c1, temp$)
			   MOVENEXT #hFile
			   IF EOF(hFile) THEN
			      MOVELAST #hFile
			      antal = antal - 1
			      counter = llen + 1
			   END IF
			   counter = counter + 1
			   MDBList = FALSE
			   EXIT FUNCTION
			ELSE
			   FOR counter = 1 TO antal
			       MOVEPREVIOUS #hFile
			   NEXT counter
			   FOR fill = counter + 1 TO llen
			       CALL VioPrint(r1 - 1 + fill, c1, SPACE$(c2 - c1 + 1))
			   NEXT fill
			   counter = 1
			   antal = 0
			   MDBList = TRUE
			   EXIT FUNCTION
			END IF
		   CASE 2
			IF temp$ = "RE" + "DRAW" THEN
			   counter = 1
			   antal = 0
			   MDBList = -1
			   EXIT FUNCTION
			END IF
			LOCATE r1, c1, 1
			CALL KbdInkey(IDKWAIT, scan, nul)
			CALL KbdClear
			LOCATE r1, c1, 0
			SELECT CASE scan
			       CASE KEYUARROW
				    skipit = -1
			       CASE KEYDARROW
				    skipit = 1
			       CASE KEYPAGEUP
				    skipit = -8
			       CASE KEYPAGEDN
				    skipit = 8
			       CASE KEYHOME
				    skipit = 10
			       CASE KEYEND
				    skipit = -10
			       CASE 1000
				    skipit = 2
			       CASE ELSE
				    MDBList = scan
				    temp$ = ""
				    EXIT FUNCTION
			END SELECT
			IF skipit <> 0 THEN
			   doredraw = TRUE
			END IF
			SELECT CASE skipit
			       CASE -1
				    MOVEPREVIOUS #hFile
			       CASE 1
				    MOVENEXT #hFile
			       CASE -8
				    FOR counter = 1 TO llen
					MOVEPREVIOUS #hFile
				    NEXT counter
			       CASE 8
				    FOR counter = 1 TO llen
					MOVENEXT #hFile
				    NEXT counter
			       CASE -10
				    MOVELAST #hFile
			       CASE 10
				    MOVEFIRST #hFile
			       CASE ELSE
			END SELECT
			IF EOF(hFile) THEN
			   MOVELAST #hFile
			END IF
			IF BOF(hFile) THEN
			   MOVEFIRST #hFile
			END IF
			IF doredraw = TRUE THEN
			   counter = 1
			   antal = 0
			   MDBList = -1
			ELSE
			   MDBList = scan
			END IF
			temp$ = ""
			EXIT FUNCTION
		   CASE 3
			' *****  EXIT PROCESSING  ******
		   CASE ELSE
	    END SELECT
	END FUNCTION

