REM     *********************************************************************
REM     * MEMO.MOD
REM     *********************************************************************
REM     * FUNCTION MemoGet$
REM     * FUNCTION MemoPut&
REM     * FUNCTION MemoM2A%
REM     * FUNCTION MemoLines%
REM     * FUNCTION MemoA2M$
REM     *
REM     *********************************************************************
REM     * 910325: Changed for New update of STLIB7
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        MemoA2M: Copy an array to a memoready string.
'       ---------------------------------------------------------------------
	SUB MemoA2M (last, txt$(), memo$)
	    memo$ = ""
	    FOR counter = 1 TO last
		memo$ = memo$ + txt$(counter) + CHR$(13) + CHR$(10)
	    NEXT counter
	END SUB

'       ---------------------------------------------------------------------
'        MemoGet$
'       ---------------------------------------------------------------------
	FUNCTION MemoGet$ (memofile$, mstart&) STATIC
	    hmemo = FREEFILE
	    mfil$ = memofile$
	    IF INSTR(mfil$, ".") = 0 THEN
	       mfil$ = mfil$ + ".MDM"
	    END IF
	    OPEN mfil$ FOR BINARY AS #hmemo
		SEEK #hmemo, mstart&
		GET #hmemo, , mlen&
		temp$ = SPACE$(mlen&)
		GET #hmemo, , temp$
	    CLOSE #hmemo
	    MemoGet$ = temp$
	END FUNCTION

'       ---------------------------------------------------------------------
'        MemoLine: Count lines in a memoready string.
'       ---------------------------------------------------------------------
	FUNCTION MemoLines (memo$)
	    quit = FALSE
	    eol = INSTR(memo$, CHR$(10))
	    IF eol = FALSE THEN
	       MemoLines = FALSE
	    END IF
	    start = 1
	    lines = 1
	    DO
	      eol = INSTR(start, memo$, CHR$(10))
	      IF eol = 0 THEN
		 MemoLines = lines
		 quit = TRUE
	      ELSE
		 lines = lines + 1
		 start = eol + 1
	      END IF
	    LOOP UNTIL quit = TRUE
	END FUNCTION

'       ---------------------------------------------------------------------
'        MemoM2A: Copy a memoready string to an array.           
'       ---------------------------------------------------------------------
	FUNCTION MemoM2A (memo$, txt$())
	    quit = FALSE
	    eol = INSTR(memo$, CHR$(10))
	    IF eol = FALSE THEN
	       MemoM2A = FALSE
	    END IF
	    start = 1
	    lines = 1
	    DO
	      eol = INSTR(start, memo$, CHR$(10))
	      IF eol = 0 THEN
		 MemoM2A = lines
		 quit = TRUE
	      ELSE
		 txt$(lines) = MID$(memo$, start, eol - start - 1)
		 lines = lines + 1
		 start = eol + 1
	      END IF
	    LOOP UNTIL quit = TRUE
	END FUNCTION

'       ---------------------------------------------------------------------
'        MemoPut&:
'       ---------------------------------------------------------------------
	FUNCTION MemoPut& (memofile$, memo$)
	    hmemo = FREEFILE
	    mfil$ = memofile$
	    IF INSTR(mfil$, ".") = 0 THEN
	       mfil$ = mfil$ + ".MDM"
	    END IF
	    OPEN mfil$ FOR BINARY AS #hmemo
		mstart& = LOF(hmemo) + 1
		mlen& = LEN(memo$)
		SEEK #hmemo, mstart&
		PUT #hmemo, , mlen&
		PUT #hmemo, , memo$
		MemoPut& = mstart&
	    CLOSE #hmemo
	END FUNCTION

