REM     ********************************************************************
REM     *
REM     *
REM     *       P R N 2 B A S           Version 0.014
REM     *
REM     *     Converts report definition file to BASIC code with fields
REM     *
REM     *
REM     *     Started: 9306007    Last: 930609    Timelog: 7h
REM     *
REM     *
REM     ********************************************************************
	REM $INCLUDE: 'STLIB.BI'
	DEFINT A-Z

	TYPE FIELDTYPE
	     sVarName   AS STRING * 32
	     sVarType   AS STRING * 1
	     iLen       AS INTEGER
	END TYPE

	REDIM sArg$(0)

	CALL FileCmdLine(sArg$(), iArg)

	IF iArg <> 2 THEN
	   PRINT "Syntax: PRN2BAS file tab"
	   END
	END IF

	sFile$ = sArg$(1)
	sTab$ = LTRIM$(sArg$(2))

	szFile$ = sFile$ + CHR$(0)
	IF DosQFile(szFile$, IDFOPEN) = FALSE THEN
	   PRINT "Cannot open: "; sFile$
	   END
	END IF

	PRINT "PRN2BAS (0.014) - "; sFile$

	hOut = FREEFILE
	OPEN "PRINT.OUT" FOR OUTPUT AS #hOut

	hFile = FREEFILE
	OPEN sFile$ FOR INPUT AS #hFile

	     PRINT #hOut, "hPrt=FREEFILE"
	     PRINT #hOut, "OPEN " + CHR$(34) + "LPT1:" + CHR$(34) + " FOR OUTPUT AS #hPrt"

	     PRINT #hOut, "iTab = "; sTab$

	     INPUT #hFile, iAntal
	     REDIM fld(iAntal) AS FIELDTYPE
	     FOR iCounter = 1 TO iAntal
		 INPUT #hFile, iVarNr
		 INPUT #hFile, sVarName$
		 INPUT #hFile, sVarType$
		 INPUT #hFile, iVarLen

		 fld(iVarNr).sVarName = StrTrim$(sVarName$)
		 fld(iVarNr).sVarType = sVarType$
		 fld(iVarNr).iLen = iVarLen

	     NEXT iCounter

	     DO
		LINE INPUT #hFile, sTmp$
		IF StrTrim$(sTmp$) = "" THEN
		   PRINT #hOut, "PRINT #hPrt,"
		ELSE
		   sTmp$ = RTRIM$(sTmp$)
		   sOut$ = ""
		   FOR iCounter = 1 TO LEN(sTmp$)
		       IF MID$(sTmp$, iCounter, 1) = "@" THEN
			  iIndex = VAL(MID$(sTmp$, iCounter + 1, 2))
			  sLen$ = LTRIM$(STR$(fld(iIndex).iLen))
			  sVar$ = StrTrim$(fld(iIndex).sVarName$)
			  SELECT CASE fld(iIndex).sVarType
				 CASE "S"
				      sVar$ = "StrFormat(IDSFSTR,SPACE$(" + sLen$ + ")," + sVar$ + ")"
				 CASE "I"
				      sVar$ = "StrFormat(IDSFINT," + CHR$(34) + STRING$(VAL(sLen$), 35) + CHR$(34) + ",STR$(" + sVar$ + "))"
				 CASE "F"
				      IF LEN(sLen$) < 2 THEN
					 sLen$ = sLen$ + "0"
				      END IF
				      iFirst = VAL(LEFT$(sLen$, 1))
				      iLast = VAL(RIGHT$(sLen$, 1))
				      IF iLast = 0 THEN
					 sVar$ = "StrFormat(IDSFDBL," + CHR$(34) + STRING$(iFirst, 35) + CHR$(34) + ",STR$(" + sVar$ + "))"
				      ELSE
					 sVar$ = "StrFormat(IDSFDBL," + CHR$(34) + STRING$(iFirst, 35) + "." + STRING$(iLast, 35) + CHR$(34) + ",STR$(" + sVar$ + "))"
				      END IF
				 CASE "D"
				      sVar$ = "StrFormat(IDSFDATE,SPACE$(" + sLen$ + ")," + sVar$ + ")"
				 CASE "T"
				      sVar$ = "StrFormat(IDSFTIME,SPACE$(" + sLen$ + ")," + sVar$ + ")"
				 CASE ELSE
			  END SELECT
			  IF iCounter > 1 THEN
			     sVar$ = CHR$(34) + ";" + sVar$
			  END IF
			  sOut$ = sOut$ + sVar$ + ";" + CHR$(34)
			  IF fld(iIndex).sVarType <> "F" THEN
			     iCounter = iCounter + VAL(sLen$)
			  ELSE
			     iFirst = VAL(LEFT$(sLen$, 1))
			     iLast = VAL(RIGHT$(sLen$, 1))
			     IF iLast = 0 THEN
				iLen = iFirst
			     ELSE
				iLen = iFirst + iLast + 1
			     END IF
			     iCounter = iCounter + iLen
			  END IF
			  bLast = TRUE
		       ELSE
			  IF iCounter = 1 THEN
			     sOut$ = sOut$ + CHR$(34)
			  END IF
			  sOut$ = sOut$ + MID$(sTmp$, iCounter, 1)
			  bLast = FALSE
		       END IF
		   NEXT
		   IF bLast = FALSE THEN
		      sOut$ = sOut$ + CHR$(34)
		   ELSE
		      sOut$ = LEFT$(sOut$, LEN(sOut$) - 2)
		   END IF
		   PRINT #hOut, "PRINT #hPrt, SPC(iTab);"; sOut$
		   iRader = iRader + 1
		END IF
	     LOOP WHILE NOT EOF(hFile)
	     PRINT #hOut, "CLOSE #hPrt"

	CLOSE #hFile

	CLOSE #hOut

	PRINT
	PRINT iRader; " rader konverterade."

