REM     *********************************************************************
REM     * STRARRAY.MOD
REM     *********************************************************************
REM     * SUB StrArraySort
REM     *
REM     *********************************************************************
REM     * 880910: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        StrArrayAdd: Adds array element to string array
'       ---------------------------------------------------------------------
	SUB StrArrayAdd (array$(), where, new$)
	    arraysize = UBOUND(array$)
	    SELECT CASE where
		   CASE IS > arraysize, 0
			EXIT SUB
		   CASE -1
			last = TRUE
		   CASE ELSE
			last = FALSE
	    END SELECT
	    REDIM PRESERVE array$(arraysize + 1)
	    IF last = TRUE THEN
	       array$(arraysize + 1) = new$
	    ELSE
	       FOR counter = arraysize + 1 TO where + 1 STEP -1
		   SWAP array$(counter), array$(counter - 1)
	       NEXT
	       array$(where) = new$
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        StrArrayDel: Deletes element from string array
'       ---------------------------------------------------------------------
	SUB StrArrayDel (array$(), where)
	    arraysize = UBOUND(array$)
	    SELECT CASE where
		   CASE IS > arraysize, IS < 1
			EXIT SUB
		   CASE ELSE
	    END SELECT
	    IF where <> arraysize THEN
	       FOR counter = where TO arraysize - 1
		   SWAP array$(counter), array$(counter + 1)
	       NEXT
	    END IF
	    REDIM PRESERVE array$(arraysize - 1)
	END SUB

'       ---------------------------------------------------------------------
'        StrArraySort:
'       ---------------------------------------------------------------------
	SUB StrArraySort (strn$(), min, max)
	    offset = max \ 2
	    DO WHILE offset > 0
	       limit = max - offset
	       DO
		  switch = FALSE
		  FOR counter = min TO limit
		      IF strn$(counter) > strn$(counter + offset) THEN
			 SWAP strn$(counter), strn$(counter + offset)
			 switch = counter
		      END IF
		  NEXT counter
		  limit = switch - offset
	       LOOP WHILE switch
	       offset = offset \ 2
	    LOOP
	END SUB

