REM     *********************************************************************
REM     * STRFORMA.MOD
REM     *********************************************************************
REM     * FUNCTION StrFormat$
REM     *
REM     *********************************************************************
REM     * 890904: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 900630: INT/DBL/DATE/TIME all added
REM     *--------------------------------------------------------------------
REM     * 930610: Changed look for Combobox.
REM     *--------------------------------------------------------------------
REM     * 930811: Fixed a bug with DOUBLE form without decimals.
REM     *--------------------------------------------------------------------
REM     * 931204: Added new WinXxxx formats and fixed BOOL double bug.
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        StrFormat$: Formats a string.       
'       ---------------------------------------------------------------------
	STATIC FUNCTION StrFormat$ (flag, form$, strn$)
	   strn$ = StrTrim(strn$)
	   SELECT CASE flag
		  CASE IDSFSTR
		       slen = LEN(strn$)
		       SELECT CASE LEN(form$)
			      CASE 0
				   StrFormat$ = ""
			      CASE slen
				   StrFormat$ = strn$
			      CASE IS > slen
				   StrFormat$ = strn$ + SPACE$(LEN(form$) - slen)
			      CASE IS < slen
				   StrFormat$ = LEFT$(strn$, LEN(form$))
			      CASE ELSE
		       END SELECT
		  CASE IDSFDROP
		       slen = LEN(strn$)
		       SELECT CASE LEN(form$)
			      CASE 0
				   StrFormat$ = "  "
			      CASE slen
				   StrFormat$ = strn$ + "  "
			      CASE IS > slen
				   StrFormat$ = strn$ + SPACE$(LEN(form$) - slen) + "  "
			      CASE IS < slen
				   StrFormat$ = LEFT$(strn$, LEN(form$)) + "  "
			      CASE ELSE
		       END SELECT
		  CASE IDSFINT
		       IF ASC(form$) = 45 THEN
			  temp = 6
		       ELSE
			  temp = 5
		       END IF
		       form$ = LEFT$(form$, temp)
		       flen = LEN(form$)
		       IF LEN(strn$) > flen THEN
			  temp$ = STRING$(flen, 35)
		       ELSE
			  temp$ = SPACE$(flen - LEN(strn$)) + strn$
		       END IF
		       StrFormat$ = temp$


		  CASE IDSFDBL
		       IF StrTrim$(st.iFloatDelim) = "" THEN
			  st.iFloatDelim = ","
		       END IF
		       IF INSTR(form$, ".") THEN
			  temp = INSTR(form$, ".")
			  len1 = temp - 1
			  len2 = LEN(form$) - temp
			  decflag = TRUE
			  temp = INSTR(strn$, ".")
			  IF temp THEN
			     num1$ = LEFT$(strn$, temp - 1)
			     num2$ = StrTrim$(LEFT$(MID$(strn$, temp + 1, LEN(strn$) - temp), len2))
			     num2$ = num2$ + STRING$(len2 - LEN(num2$), "0")
			  ELSE
			     num1$ = strn$
			     num2$ = STRING$(len2, "0")
			  END IF
			  strn$ = num1$ + st.iFloatDelim + num2$
		       ELSE
			  temp = INSTR(strn$, ".")
			  IF temp THEN
			     strn$ = LEFT$(strn$, temp - 1)
			  END IF
		       END IF
		       flen = LEN(form$)
		       IF LEN(strn$) > flen THEN
			  temp$ = STRING$(flen, 35)
		       ELSE
			  temp$ = SPACE$(flen - LEN(strn$)) + strn$
		       END IF
		       StrFormat$ = temp$
		  CASE IDSFDATE
		       IF StrTrim$(st.iDateDelim) = "" THEN
			  st.iDateDelim = "/"
		       END IF
		       IF StrTrim$(form$) = "" THEN
			  d$ = st.iDateDelim
		       ELSE
			  d$ = LEFT$(form$, 1)
		       END IF
		       IF StrTrim$(strn$) = "" THEN
			  StrFormat$ = RIGHT$(DATE$, 2) + d$ + LEFT$(DATE$, 2) + d$ + MID$(DATE$, 4, 2)
			  strn$ = RIGHT$(DATE$, 2) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2)
		       ELSE
			  StrFormat$ = LEFT$(strn$, 2) + d$ + MID$(strn$, 3, 2) + d$ + RIGHT$(strn$, 2)
		       END IF
		  CASE IDSFTIME
		       IF StrTrim$(st.iTimeDelim) = "" THEN
			  st.iTimeDelim = ":"
		       END IF
		       IF StrTrim$(form$) = "" THEN
			  d$ = st.iTimeDelim
		       ELSE
			  d$ = LEFT$(form$, 1)
		       END IF
		       IF StrTrim$(strn$) = "" THEN
			  StrFormat$ = LEFT$(TIME$, 2) + d$ + MID$(TIME$, 4, 2)
			  strn$ = LEFT$(TIME$, 2) + MID$(TIME$, 4, 2)
		       ELSE
			  StrFormat$ = LEFT$(strn$, 2) + d$ + MID$(strn$, 3, 2)
		       END IF
		  CASE IDSFBOOL
		       StrFormat$ = MID$(form$, VAL(strn$) + 1, 1)
		  CASE IDSFCHK
		       IF VAL(strn$) = 0 THEN
			  StrFormat$ = "[ ] " + form$
		       ELSE
			  StrFormat$ = "[X] " + form$
		       END IF
		  CASE IDSFOPT
		       IF VAL(strn$) = 0 THEN
			  StrFormat$ = "( ) " + form$
		       ELSE
			  StrFormat$ = "(" + CHR$(7) + ") " + form$
		       END IF
		  CASE ELSE
	   END SELECT
	END FUNCTION

