REM     *********************************************************************
REM     * VIO.MOD
REM     *********************************************************************
REM     * FUNCTION VioColor
REM     * FUNCTION VioSpace$
REM     *
REM     *********************************************************************
REM     * 881002: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 930418: Added support for new colortable (Set/Query)
REM     *--------------------------------------------------------------------
REM     * 930419: Added VioOpenWindow/VioCloseWindow.
REM     *--------------------------------------------------------------------
REM     * 930428: Added VioBackground.
REM     *--------------------------------------------------------------------
REM     * 930610: Removed new Vio... functions.
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

DEFINT A-Z
'       --------------------------------------------------------------------
'        VioColor: Calculates attribute bit of fore,back pair.       900629
'       --------------------------------------------------------------------
	FUNCTION VioColor (f, b)
	    temp = (f AND 16) * 8 + (b * 16) + (f AND 15)
	    IF temp AND 128 THEN
	       temp = temp - 128
	    END IF
	    VioColor = temp
	END FUNCTION

'       --------------------------------------------------------------------
'        VioSpace: Returns string enough to save part of screen      930418
'       --------------------------------------------------------------------
	FUNCTION VioSpace$ (row1, col1, row2, col2)
	    temp1 = row2 - row1
	    temp2 = (col2 - col1) + 1
	    temp = ((temp1 * temp2) + temp2) * 2
	    VioSpace$ = STRING$(temp + temp2, 0)
	END FUNCTION

