DECLARE FUNCTION EditInt% (value%, row%, col%, fmt$, ret%())
DECLARE FUNCTION ENIntEdit% (num$, row%, col%, frmat$, ret%())
REM     *********************************************************************
REM     * EDITINT.MOD
REM     *********************************************************************
REM     * FUNCTION EditInt%
REM     *********************************************************************
REM     * 870513: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 900630: Lots of bugs fixed/ ENFormat added
REM     *--------------------------------------------------------------------
REM     * 900708: Total rewrite. Mouse support added
REM     *--------------------------------------------------------------------
REM     * 921127: Mouse support removed
REM     *--------------------------------------------------------------------
REM     * 930419: Chnged for new color settings
REM     *--------------------------------------------------------------------
REM     * 930610: Fixed colours for new field look.
REM     *--------------------------------------------------------------------
REM     * 931107: Split into two files.
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        EditInt:
'       ---------------------------------------------------------------------
	FUNCTION EditInt (value, row, col, fmt$, ret())
	    temp$ = StrFormat$(IDSFINT, fmt$, STR$(value))
	    IF ASC(temp$) = 35 THEN
	       temp$ = ""
	    END IF
	    ret = ENIntEdit(temp$, row, col, fmt$, ret())
	    value = VAL(temp$)
	    EditInt = ret
	END FUNCTION

'       ---------------------------------------------------------------------
'        ENIntEdit:
'       ---------------------------------------------------------------------
	FUNCTION ENIntEdit (num$, row, col, frmat$, ret())
	   IF ASC(frmat$) = 45 THEN
	      IF INSTR(num$, "-") THEN
		 neg$ = "-"
	      ELSE
		 neg$ = " "
	      END IF
	      fmt$ = RIGHT$(frmat$, LEN(frmat$) - 1)
	      neg = TRUE
	   ELSE
	      neg$ = ""
	      fmt$ = frmat$
	      neg = FALSE
	   END IF
	   temp = INSTR(num$, "-")
	   IF temp THEN
	      MID$(num$, temp, 1) = " "
	   END IF

	   len1 = LEN(fmt$)
	   len2 = 0
	   num1$ = RIGHT$(num$, len1)
	   num2$ = ""
	   dec = FALSE

	   num$ = neg$ + num1$ + num2$

	   COLOR st.iGloefcolor, st.iGloebcolor

	   kpress = FALSE
	   quit = FALSE
	   DO
	      IF neg = TRUE THEN
		 tcol = col + len1
	      ELSE
		 tcol = col + len1 - 1
	      END IF
	      temp$ = num$

	      LOCATE row, col
	      PRINT temp$;
	      LOCATE row, tcol, 1
	      CALL KbdInkey(IDKWAIT, keycode, shift)
	      LOCATE , , 0

	      SELECT CASE keycode
		     CASE ASC("-")
			  IF neg = TRUE THEN
			     IF neg$ = " " THEN
				neg$ = "-"
				MID$(num$, 1, 1) = "-"
			     ELSE
				neg$ = " "
				MID$(num$, 1, 1) = " "
			     END IF
			  END IF

		     CASE 48 TO 57
			  IF kpress = FALSE THEN
			     IF neg THEN
				num$ = SPACE$(len1 + 1)
			     ELSE
				num$ = SPACE$(len1)
			     END IF
			  END IF
			  IF neg THEN
			     temp$ = LTRIM$(RIGHT$(num$, LEN(num$) - 1)) + CHR$(keycode)
			  ELSE
			     temp$ = LTRIM$(num$) + CHR$(keycode)
			  END IF
			  IF neg THEN
			     IF LEN(temp$) <= len1 THEN
				MID$(num$, 2) = SPACE$(len1 - LEN(temp$)) + temp$
			     END IF
			  ELSE
			     IF LEN(temp$) <= len1 THEN
				MID$(num$, 1) = SPACE$(len1 - LEN(temp$)) + temp$
			     END IF
			  END IF

		     CASE KEYBKSP, KEYDEL
			  IF neg THEN
			     num$ = neg$ + " " + MID$(num$, 2, LEN(num$) - 2)
			  ELSE
			     num$ = " " + LEFT$(num$, LEN(num$) - 1)
			  END IF

		     CASE ELSE
			  FOR counter = 1 TO UBOUND(ret)
			      IF ret(counter) = keycode THEN
				 quit = TRUE
				 ENIntEdit = keycode
				 EXIT FOR
			      END IF
			  NEXT counter
	      END SELECT
	      kpress = TRUE
	   LOOP WHILE quit = FALSE

	   IF neg = TRUE THEN
	      tcol = col + len1
	   ELSE
	      tcol = col + len1 - 1
	   END IF
	   temp$ = num$

	   COLOR st.iGloffcolor, st.iGlofbcolor
	   LOCATE row, col
	   PRINT temp$;
	END FUNCTION

'       ---------------------------------------------------------------------
'        WinEditInt:
'       ---------------------------------------------------------------------
	FUNCTION WinEditInt (hwnd AS WINDOWTYPE, iValue, iRow, iCol, sForm$, iRet())
	    iWinRow = iRow
	    iWinCol = iCol
	    iLen = LEN(sForm$)
	    CALL ValidPos(hwnd, iWinRow, iWinCol, iLen)
	    CALL SetColor(hwnd)
	    sForm$ = LEFT$(sForm$, iLen)
	    WinEditInt = EditInt(iValue, iWinRow, iWinCol, sForm$, iRet())
	END FUNCTION

