DECLARE SUB SetColor (hwnd AS ANY)
DECLARE SUB ValidPos (hwnd AS ANY, iRow%, iCol%, iLen%)
DECLARE FUNCTION ESChkRet% (ret%, row%, col%, fieldid%, retur%(), quit%)
DECLARE FUNCTION ESChkTimeRet% (ret%, row%, col%, fieldid%, retur%(), quit%)
DECLARE SUB ESHook (hook%, keyret%, shift%)
REM     *********************************************************************
REM     * EDITSTR.MOD
REM     *********************************************************************
REM     * FUNCTION EditString%
REM     * FUNCTION EditDate%
REM     * FUNCTION EditTime%
REM     *
REM     *********************************************************************
REM     * 890328: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 900630: Exit with <-/-> removed. Bugs in EditTime fixed
REM     *--------------------------------------------------------------------
REM     * 900706: EditString using string, full mouse support
REM     *--------------------------------------------------------------------
REM     * 900907: EditTime changed to HH/MM (seconds skipped)
REM     *--------------------------------------------------------------------
REM     * 921127: Mouse support removed
REM     *--------------------------------------------------------------------
REM     * 930419: Change for new color settings
REM     *--------------------------------------------------------------------
REM     * 930426: Fixed ; for print on line 24,25
REM     *--------------------------------------------------------------------
REM     * 930603: Fixed bug that did NOT allow 1900/2000 (00 year)
REM     *--------------------------------------------------------------------
REM     * 930610: Fixed colours for new field look and added IDHPSW.
REM     *--------------------------------------------------------------------
REM     * 931107: Split into three files
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'

DEFINT A-Z
'       ---------------------------------------------------------------------
'        EditString: Give user fixed length input of string.          891105
'       ---------------------------------------------------------------------
	FUNCTION EditString (data$, row, colhome, length, ret(), hook)
	    kpress = FALSE
	    data$ = LEFT$(data$, length)
	    data$ = data$ + SPACE$(length - LEN(data$))
	    col = colhome
	    colend = col + length - 1
	    strpos = 1

	    COLOR st.iGloefcolor, st.iGloebcolor

	    redraw = TRUE
	    quit = FALSE
	    DO
	       IF redraw = TRUE THEN
		  LOCATE row, colhome
		  IF hook <> IDHPSW THEN
		     PRINT data$;
		  ELSE
		     PRINT SPACE$(length)
		  END IF
		  redraw = FALSE
	       END IF
	       LOCATE row, col, 1
	       CALL KbdInkey(IDKWAIT, keyret, shift)
	       LOCATE row, col, 0
	       CALL ESHook(hook, keyret, shift)

	       SELECT CASE keyret
		      CASE IS > 31
			   IF kpress = FALSE THEN
			      data$ = SPACE$(length)
			   END IF
			   temp1$ = LEFT$(data$, strpos - 1)
			   temp2$ = RIGHT$(data$, length - strpos + 1)

			   IF LEN(temp2$) > 0 THEN
			      temp2$ = LEFT$(temp2$, LEN(temp2$) - 1)
			   ELSE
			      temp2$ = ""
			   END IF
			   data$ = temp1$ + CHR$(keyret) + temp2$
			   strpos = strpos + 1
			   IF strpos - 1 = length THEN
			      FOR counter = 1 TO UBOUND(ret)
				  IF ret(counter) = KEYXLAST THEN
				     EditString = KEYXLAST
				     quit = TRUE
				  END IF
			      NEXT counter
			   END IF
			   redraw = TRUE
		      CASE KEYRARROW
			   strpos = strpos + 1
		      CASE KEYLARROW
			   strpos = strpos - 1
		      CASE KEYHOME
			   temp$ = LTRIM$(data$)
			   strpos = LEN(data$) - LEN(temp$) + 1
		      CASE KEYEND
			   temp$ = RTRIM$(data$)
			   strpos = LEN(temp$) + 1
		      CASE KEYDEL
			   IF strpos = length THEN
			      MID$(data$, length, 1) = " "
			   ELSE
			      temp1$ = LEFT$(data$, strpos - 1)
			      temp2$ = RIGHT$(data$, length - strpos)
			      data$ = temp1$ + temp2$ + " "
			   END IF
			   redraw = TRUE
		      CASE KEYBKSP
			   IF strpos > 1 THEN
			      temp1$ = LEFT$(data$, strpos - 2)
			      temp2$ = RIGHT$(data$, length - strpos + 1)
			      data$ = temp1$ + temp2$ + " "
			      strpos = strpos - 1
			      redraw = TRUE
			   END IF
		      CASE ELSE
			   FOR counter = 1 TO UBOUND(ret)
			       IF ret(counter) = keyret THEN
				  EditString = keyret
				  quit = TRUE
				  EXIT FOR
			       END IF
			   NEXT counter
	       END SELECT
	       kpress = TRUE
	       IF strpos < 1 THEN
		  strpos = 1
	       END IF
	       IF strpos > length THEN
		  strpos = length
	       END IF
	       col = colhome + strpos - 1
	    LOOP WHILE quit = FALSE

	    COLOR st.iGloffcolor, st.iGlofbcolor
	    LOCATE row, colhome
	    IF hook <> IDHPSW THEN
	       PRINT data$;
	    ELSE
	       PRINT SPACE$(length)
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        ESChkRet:
'       ---------------------------------------------------------------------
	FUNCTION ESChkRet (ret, row, col, fieldid, retur(), quit)
	    SELECT CASE ret
		   CASE KEYENTER
			fieldid = fieldid + 1
			IF fieldid > 3 THEN
			   FOR counter = 1 TO UBOUND(retur)
			       IF retur(counter) = KEYENTER THEN
				  quit = TRUE
				  ESChkRet = KEYENTER
			       END IF
			   NEXT counter
			END IF
		   CASE KEYTAB
			fieldid = fieldid + 1
			IF fieldid > 3 THEN
			   FOR counter = 1 TO UBOUND(retur)
			       IF retur(counter) = KEYTAB THEN
				  quit = TRUE
				  ESChkRet = KEYTAB
			       END IF
			   NEXT counter
			END IF
		   CASE ELSE
			FOR counter = 1 TO UBOUND(retur)
			    IF retur(counter) = ret THEN
			       quit = TRUE
			       ESChkRet = ret
			    END IF
			NEXT counter
	       END SELECT
	END FUNCTION

'       ---------------------------------------------------------------------
'        ESHook: Here programmer can add hooks to EditString.       880420
'       ---------------------------------------------------------------------
	SUB ESHook (hook, keyret, shift)
	    IF keyret < 1 THEN
	       EXIT SUB
	    END IF
	    SELECT CASE hook
		   CASE IDHUCASE
			SELECT CASE keyret
			       CASE 97 TO 122
				    keyret = keyret - 32
			       CASE ASC("")
				    keyret = ASC("")
			       CASE ASC("")
				    keyret = ASC("")
			       CASE ASC("")
				    keyret = ASC("")
			       CASE ASC("")
				    keyret = ASC("")
			       CASE ELSE
			END SELECT
		   CASE IDHTIME, IDHDATE
			IF keyret > 31 THEN
			   IF NOT (keyret > 47 AND keyret < 60) THEN
			      keyret = 0
			   END IF
			END IF
		   CASE IDHNUM
			numeric$ = "0123456789"
			IF keyret > 32 THEN
			   IF INSTR(numeric$, CHR$(keyret)) = 0 THEN
			      keyret = 0
			   END IF
			END IF
		   CASE IDHFILE
			SELECT CASE keyret
			       CASE 97 TO 122
				    keyret = keyret - 32
			       CASE ASC("")
				    keyret = ASC("")
			       CASE ASC("")
				    keyret = ASC("")
			       CASE ASC("")
				    keyret = ASC("")
			       CASE ELSE
			END SELECT
			fkey$ = "\/?+*,;:<>=|[]" + CHR$(255) + CHR$(32) + CHR$(34)
			IF keyret > 32 THEN
			   IF INSTR(fkey$, CHR$(keyret)) <> 0 THEN
			      keyret = 0
			   END IF
			END IF
		   CASE IDHPSW
		   CASE ELSE
	    END SELECT
	END SUB

'       ---------------------------------------------------------------------
'        WinEditString: EditString in a Window...
'       ---------------------------------------------------------------------
	FUNCTION WinEditString (hwnd AS WINDOWTYPE, sText$, iRow, iCol, iLen, iRet(), iHook)
	    iWinRow = iRow
	    iWinCol = iCol
	    iWinLen = iLen
	    CALL ValidPos(hwnd, iWinRow, iWinCol, iWinLen)
	    CALL SetColor(hwnd)
	    WinEditString = EditString(sText$, iWinRow, iWinCol, iWinLen, iRet(), iHook)
	END FUNCTION

