DECLARE FUNCTION EditDate% (eddate$, row%, col%, retur%())
DECLARE SUB SetColor (hwnd AS ANY)
DECLARE SUB ValidPos (hwnd AS ANY, iRow%, iCol%, iLen%)
DECLARE FUNCTION ESChkDateRet% (ret%, row%, col%, fieldid%, retur%(), quit%)
REM     *********************************************************************
REM     * EDITDATE.MOD
REM     *********************************************************************
REM     * FUNCTION EditDate%
REM     *
REM     *********************************************************************
REM     * 890328: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 900630: Exit with <-/-> removed. Bugs in EditTime fixed
REM     *--------------------------------------------------------------------
REM     * 900706: EditString using string, full mouse support
REM     *--------------------------------------------------------------------
REM     * 900907: EditTime changed to HH/MM (seconds skipped)
REM     *--------------------------------------------------------------------
REM     * 921127: Mouse support removed
REM     *--------------------------------------------------------------------
REM     * 930419: Change for new color settings
REM     *--------------------------------------------------------------------
REM     * 930426: Fixed ; for print on line 24,25
REM     *--------------------------------------------------------------------
REM     * 930603: Fixed bug that did NOT allow 1900/2000 (00 year)
REM     *--------------------------------------------------------------------
REM     * 930610: Fixed colours for new field look and added IDHPSW.
REM     *--------------------------------------------------------------------
REM     * 931107: Split into three files
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        EditDate: Get date input.                                    880624
'       ---------------------------------------------------------------------
	FUNCTION EditDate (eddate$, row, col, retur())
	    year$ = RIGHT$(DATE$, 2)
	    month$ = LEFT$(DATE$, 2)
	    day$ = MID$(DATE$, 4, 2)
	    baddate = FALSE
	    IF LEN(eddate$) = 6 THEN
	       temp$ = LEFT$(eddate$, 2)
	       year$ = temp$
	       temp$ = MID$(eddate$, 3, 2)
	       IF VAL(temp$) > 0 AND VAL(temp$) < 13 THEN
		  month$ = temp$
	       END IF
	       temp$ = RIGHT$(eddate$, 2)
	       IF VAL(temp$) > 0 AND VAL(temp$) < 32 THEN
		  day$ = temp$
	       END IF
	    END IF
	    IF StrTrim$(st.iDateDelim) = "" THEN
	       st.iDateDelim = "/"
	    END IF

	    COLOR st.iGloefcolor, st.iGloebcolor

	    LOCATE row, col
	    PRINT year$; st.iDateDelim; month$; st.iDateDelim; day$;
	    REDIM ret(UBOUND(retur) + 3)
	    FOR counter = 1 TO UBOUND(retur)
		ret(counter) = retur(counter)
	    NEXT counter
	    ret(UBOUND(retur) + 1) = KEYXLAST
	    ret(UBOUND(retur) + 2) = KEYENTER
	    ret(UBOUND(retur) + 3) = KEYTAB
	    quit = FALSE
	    fieldid = 1
	    DO
	       SELECT CASE fieldid
		      CASE 1
			   quit1 = FALSE
			   DO
			      old$ = year$
			      ret = EditString(year$, row, col, 2, ret(), IDHDATE)
			      IF VAL(year$) > 0 THEN
				 quit1 = TRUE
			      ELSE
				 year$ = old$
				 BEEP
			      END IF
			   LOOP UNTIL quit1 = TRUE
		      CASE 2
			   quit1 = FALSE
			   DO
			      old$ = month$
			      ret = EditString(month$, row, col + 3, 2, ret(), IDHDATE)
			      IF VAL(month$) > 0 AND VAL(month$) < 13 THEN
				 quit1 = TRUE
			      ELSE
				 month$ = old$
				 BEEP
			      END IF
			   LOOP UNTIL quit1 = TRUE
		      CASE 3
			   quit1 = FALSE
			   DO
			      old$ = day$
			      ret = EditString(day$, row, col + 6, 2, ret(), IDHDATE)
			      IF VAL(day$) > 0 AND VAL(day$) < 32 THEN
				 quit1 = TRUE
			      ELSE
				 day$ = old$
				 BEEP
			      END IF
			   LOOP UNTIL quit1 = TRUE
		      CASE ELSE
	       END SELECT

	       COLOR st.iGloefcolor, st.iGloebcolor
	       LOCATE row, col
	       PRINT year$; st.iDateDelim; month$; st.iDateDelim; day$;

	       EditDate = ESChkDateRet(ret, row, col, fieldid, retur(), quit)

	       IF fieldid > 3 THEN
		  fieldid = 3
	       ELSEIF fieldid < 1 THEN
		  fieldid = 1
	       END IF
	    LOOP WHILE quit = FALSE
	    eddate$ = year$ + month$ + day$

	    COLOR st.iGloffcolor, st.iGlofbcolor

	    LOCATE row, col
	    PRINT year$; st.iDateDelim; month$; st.iDateDelim; day$;

	END FUNCTION

'       ---------------------------------------------------------------------
'        ESChkRet:
'       ---------------------------------------------------------------------
	FUNCTION ESChkDateRet (ret, row, col, fieldid, retur(), quit)
	    SELECT CASE ret
		   CASE KEYENTER
			fieldid = fieldid + 1
			IF fieldid > 3 THEN
			   FOR counter = 1 TO UBOUND(retur)
			       IF retur(counter) = KEYENTER THEN
				  quit = TRUE
				  ESChkRet = KEYENTER
			       END IF
			   NEXT counter
			END IF
		   CASE KEYTAB
			fieldid = fieldid + 1
			IF fieldid > 3 THEN
			   FOR counter = 1 TO UBOUND(retur)
			       IF retur(counter) = KEYTAB THEN
				  quit = TRUE
				  ESChkRet = KEYTAB
			       END IF
			   NEXT counter
			END IF
		   CASE ELSE
			FOR counter = 1 TO UBOUND(retur)
			    IF retur(counter) = ret THEN
			       quit = TRUE
			       ESChkRet = ret
			    END IF
			NEXT counter
	       END SELECT
	END FUNCTION

'       ---------------------------------------------------------------------
'        WinEditDate:
'       ---------------------------------------------------------------------
	FUNCTION WinEditDate (hwnd AS WINDOWTYPE, sDate$, iRow, iCol, iRet())
	    iWinRow = iRow
	    iWinCol = iCol
	    iLen = 8
	    CALL ValidPos(hwnd, iWinRow, iWinCol, iLen)
	    IF iLen = 8 THEN
	       CALL SetColor(hwnd)
	       WinEditDate = EditDate(sDate$, iWinRow, iWinCol, iRet())
	    END IF
	END FUNCTION

