REM     *********************************************************************
REM     * WLISTBOX.MOD
REM     *********************************************************************
REM     * FUNCTION ListBox
REM     *
REM     *********************************************************************
REM     * 871004: Created
REM     *--------------------------------------------------------------------
REM     * 900629: Changed for New update of STLIB7
REM     *--------------------------------------------------------------------
REM     * 900701: Position meter added though not functioning
REM     *--------------------------------------------------------------------
REM     * 901228: Changed to use 'callback' and TYPE variable and STATIC
REM     *         1) Set items in type varibble
REM     *         2) Call with 0 to show listbox
REM     *         3) Loop calling with 1 to get keys
REM     *         4) Clean up by calling with 2
REM     *--------------------------------------------------------------------
REM     * 921127: Mouse support removed
REM     *--------------------------------------------------------------------
REM     * 930419: Changed for new color settings
REM     *--------------------------------------------------------------------
REM     * 931107: Added WinListBox
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        ListBox: Puts list on screen to choose from.               901228
'       ---------------------------------------------------------------------
	FUNCTION ListBox (li AS LISTBOXTYPE, lbtype, ldata$())
	    SELECT CASE lbtype
		   CASE 0:              ' First time, setup list
			li.ivio = VioColor(st.iGloefcolor, st.iGloebcolor)
			li.nvio = VioColor(st.iGloebcolor, st.iGloefcolor)
			IF li.frame = TRUE THEN
			   CALL VioFrame(li.row1, li.col1, li.row2, li.col2, li.nvio, 0)
			   CALL VioPrint(li.row1 + 1, li.col2, CHR$(24))
			   FOR counter = li.row1 + 2 TO li.row2 - 2
			       CALL VioPrint(counter, li.col2, CHR$(177))
			   NEXT counter
			   CALL VioPrint(li.row2 - 1, li.col2, CHR$(25))
			   li.row1 = li.row1 + 1
			   li.col1 = li.col1 + 1
			   li.row2 = li.row2 - 1
			   li.col2 = li.col2 - 1
			END IF
			IF li.llen = 0 THEN
			   li.llen = UBOUND(ldata$)
			END IF
			li.lvisible = li.row2 - li.row1 + 1
			IF li.lvisible > li.llen THEN
			   li.lvisible = li.llen
			END IF
			lwidth = li.col2 - li.col1 + 1
			IF li.startat = 0 THEN
			   li.offset = 1
			   li.curRow = 1
			ELSE
			   IF li.startat > li.llen THEN
			      li.startat = 1
			   END IF
			   SELECT CASE li.startat
				  CASE IS <= li.lvisible
				       li.offset = 1
				       li.curRow = li.startat
				  CASE ELSE
				       IF li.startat > (li.llen - li.lvisible + 1) THEN
					  li.offset = li.startat - li.lvisible + 1
					  li.curRow = li.startat - li.offset + 1
				       ELSE
					  li.offset = li.startat
					  li.curRow = 1
				       END IF
			   END SELECT
			END IF
			FOR counter = li.row1 TO li.row2
			    temp = li.offset + (counter - (li.row1))
			    CALL VioCPrint(counter, li.col1, li.nvio, SPACE$(lwidth))
			    IF temp <= li.llen THEN
			       CALL VioPrint(counter, li.col1, LEFT$(ldata$(temp), lwidth))
			    END IF
			NEXT counter

			li.curpos = 1
			ListBox = TRUE
			EXIT FUNCTION
		   CASE 1:              ' Poll list
			current = li.offset + li.curRow - 1
			iScrpos = li.row1 + li.curRow - 1
			lwidth = li.col2 - li.col1 + 1
			IF li.redraw = TRUE THEN
			   FOR counter = li.row1 TO li.row2
			       temp = li.offset + (counter - (li.row1))
			       CALL VioCPrint(counter, li.col1, li.nvio, SPACE$(lwidth))
			       IF temp <= li.llen THEN
				  CALL VioPrint(counter, li.col1, LEFT$(ldata$(temp), lwidth))
			       END IF
			   NEXT counter
			END IF
			curItem$ = LEFT$(ldata$(current), lwidth)
			CALL VioCPrint(iScrpos, li.col1, li.ivio, SPACE$(lwidth))
			CALL VioCPrint(iScrpos, li.col1, li.ivio, curItem$)

			CALL KbdInkey(IDKWAIT, keycode, shift)

			CALL VioCPrint(iScrpos, li.col1, li.nvio, SPACE$(lwidth))
			CALL VioCPrint(iScrpos, li.col1, li.nvio, curItem$)

			SELECT CASE keycode
			       CASE KEYUARROW
				    li.curRow = li.curRow - 1
			       CASE KEYDARROW
				    li.curRow = li.curRow + 1
			       CASE KEYPAGEDN
				    li.offset = li.offset + li.lvisible
			       CASE KEYPAGEUP
				    li.offset = li.offset - li.lvisible
			       CASE KEYHOME
				    li.offset = 1
				    li.curRow = 1
			       CASE KEYEND
				    li.offset = li.llen - li.lvisible + 1
				    li.curRow = li.lvisible
			       CASE KEYSPACE
				    IF li.mark = TRUE THEN
				       IF LEN(ldata$(current)) > 1 THEN
					  IF MID$(ldata$(current), 1, 1) = "" THEN
					     MID$(ldata$(current), 1, 1) = " "
					  ELSE
					     MID$(ldata$(current), 1, 1) = ""
					  END IF
					  CALL VioCPrint(iScrpos, li.col1, li.nvio, LEFT$(ldata$(current), lwidth))
					  li.curRow = li.curRow + 1
				       END IF
				    END IF
			       CASE ELSE
				    li.curpos = current
				    ListBox = keycode
				    EXIT FUNCTION
			END SELECT

			IF li.curRow < 1 THEN
			   li.curRow = 1
			   li.offset = li.offset - 1
			ELSEIF li.curRow > li.lvisible THEN
			   li.curRow = li.lvisible
			   li.offset = li.offset + 1
			ELSE
			   li.redraw = FALSE
			END IF
			IF li.offset > li.llen - li.lvisible + 1 THEN
			   li.offset = li.llen - li.lvisible + 1
			   li.redraw = FALSE
			END IF
			IF li.offset < 1 THEN
			   li.offset = 1
			   li.redraw = FALSE
			END IF
			IF li.oldoffset <> li.offset THEN
			   li.redraw = TRUE
			END IF

			li.oldoffset = li.offset

			li.curpos = li.offset + li.curRow - 1
			ListBox = keycode
			EXIT FUNCTION
		   CASE 2:              ' Exit Listbox
			ListBox = TRUE
		   CASE ELSE
	    END SELECT

	END FUNCTION

'       ---------------------------------------------------------------------
'        WinListBox:
'       ---------------------------------------------------------------------
	FUNCTION WinListBox (hwnd AS WINDOWTYPE, li AS LISTBOXTYPE, lbfunc, ldata$())
	    IF lbfunc = 0 THEN
	       li.row1 = hwnd.iRow1 + li.row1
	       li.col1 = hwnd.iCol1 + li.col1
	       li.row2 = li.row2 + li.row1
	       li.col2 = li.col2 + li.col1
	       CALL SetColor(hwnd)
	    END IF
	    WinListBox = ListBox(li, lbfunc, ldata$())
	END FUNCTION

