DECLARE SUB QueryDefault (iShade%, iZoom%, iFrame%, fZoomTime!, bf%, bb%, wf%, wb%, ff%, fb%, ef%, eb%)
DECLARE SUB RestoreColor (hwnd AS ANY)
DECLARE SUB SaveColor (hwnd AS ANY)
DECLARE SUB SetColor (hwnd AS ANY)
DECLARE FUNCTION StrCenter% (x1%, x2%, s$)
DECLARE SUB ValidPos (hwnd AS ANY, iRow%, iCol%, iLen%)
DECLARE SUB ZoomWindow (iRow1%, iCol1%, iRow2%, iCol2%, iColor%, iFrame%)
REM     *********************************************************************
REM     *
REM     *  W I N D O W I N G   L I B R A R Y   F O R    V B / D O S
REM     *  ----------------------------------------------------------
REM     *
REM     *  Started: 930501     Last: 931011      Timelog: 23h
REM     *
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        QueryDefault:
'       ---------------------------------------------------------------------
	SUB QueryDefault (iShade, iZoom, iFrame, fZoomTime!, bf, bb, wf, wb, ff, fb, ef, eb)
	    STATIC iCalled
	    IF iCalled = FALSE THEN
	       iShade = FALSE
	       iZoom = FALSE
	       
	       IF VioQueryColor(void) = TRUE THEN
		  bf = BLACK
		  bb = WHITE
		  wf = BLACK
		  wb = WHITE
		  ff = BLACK
		  fb = WHITE
		  ef = WHITE
		  eb = BLACK
	       ELSE
		  bf = BLACK
		  bb = WHITE
		  wf = BLACK
		  wb = WHITE
		  ff = BLACK
		  fb = BRRED
		  ef = WHITE
		  eb = BLACK
	       END IF

	       st.iGloFrame = iFrame
	       st.iGloShade = iShade
	       st.iGloZoom = iZoom

	       st.fGloZoomTime! = .06

	       st.iGlobfcolor = bf
	       st.iGlobbcolor = bb
	       st.iGlowfcolor = wf
	       st.iGlowbcolor = wb
	       st.iGloffcolor = ff
	       st.iGlofbcolor = fb
	       st.iGloefcolor = ef
	       st.iGloebcolor = eb

	       iCalled = TRUE
	    ELSE
	       iFrame = st.iGloFrame
	       iShade = st.iGloShade
	       iZoom = st.iGloZoom

	       fZoomTime! = st.fGloZoomTime!

	       bf = st.iGlobfcolor
	       bb = st.iGlobbcolor
	       wf = st.iGlowfcolor
	       wb = st.iGlowbcolor
	       ff = st.iGloffcolor
	       fb = st.iGlofbcolor
	       ef = st.iGloefcolor
	       eb = st.iGloebcolor
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        RestoreColor:
'       ---------------------------------------------------------------------
	SUB RestoreColor (hwnd AS WINDOWTYPE)
	    sColor$ = hwnd.oldcolor
	    st.iGlobfcolor = ASC(MID$(sColor$, 1, 1))
	    st.iGlobbcolor = ASC(MID$(sColor$, 2, 1))
	    st.iGlowfcolor = ASC(MID$(sColor$, 3, 1))
	    st.iGlowbcolor = ASC(MID$(sColor$, 4, 1))
	    st.iGloffcolor = ASC(MID$(sColor$, 5, 1))
	    st.iGlofbcolor = ASC(MID$(sColor$, 6, 1))
	    st.iGloefcolor = ASC(MID$(sColor$, 7, 1))
	    st.iGloebcolor = ASC(MID$(sColor$, 8, 1))
	END SUB

'       ---------------------------------------------------------------------
'        SaveColor$:
'       ---------------------------------------------------------------------
	SUB SaveColor (hwnd AS WINDOWTYPE)
	    sColor$ = CHR$(st.iGlobfcolor)
	    sColor$ = sColor$ + CHR$(st.iGlobbcolor)
	    sColor$ = sColor$ + CHR$(st.iGlowfcolor)
	    sColor$ = sColor$ + CHR$(st.iGlowbcolor)
	    sColor$ = sColor$ + CHR$(st.iGloffcolor)
	    sColor$ = sColor$ + CHR$(st.iGlofbcolor)
	    sColor$ = sColor$ + CHR$(st.iGloefcolor)
	    sColor$ = sColor$ + CHR$(st.iGloebcolor)
	    hwnd.oldcolor = sColor$
	END SUB

'       ---------------------------------------------------------------------
'        SetColor:
'       ---------------------------------------------------------------------
	SUB SetColor (hwnd AS WINDOWTYPE)
	    st.iGlobfcolor = hwnd.bfcolor
	    st.iGlobbcolor = hwnd.bbcolor
	    st.iGlowfcolor = hwnd.wfcolor
	    st.iGlowbcolor = hwnd.wbcolor
	    st.iGloffcolor = hwnd.efcolor
	    st.iGlofbcolor = hwnd.ebcolor
	    st.iGloefcolor = hwnd.efcolor
	    st.iGloebcolor = hwnd.ebcolor
	END SUB

'       ---------------------------------------------------------------------
'        StrCenter: Center a string within x1-x2.
'       ---------------------------------------------------------------------
	FUNCTION StrCenter (x1, x2, s$)
	    temp = x2 - x1
	    IF LEN(s$) >= temp THEN
	       StrCenter = x1
	    ELSE
	       temp1 = LEN(s$) \ 2
	       temp2 = x1 + temp \ 2
	       StrCenter = temp2 - temp1
	    END IF
	END FUNCTION

'       ---------------------------------------------------------------------
'        ValidPos: Validates positions (to be within window).
'       ---------------------------------------------------------------------
	SUB ValidPos (hwnd AS WINDOWTYPE, iRow, iCol, iLen)
	    iRow = hwnd.iRow1 + iRow
	    iCol = hwnd.iCol1 + iCol
	    IF iRow >= hwnd.iRow2 THEN
	       iRow = hwnd.iRow2 - 1
	    END IF
	    IF iCol >= hwnd.iCol2 THEN
	       iCol = hwnd.iCol2 - 1
	    END IF
	    IF iCol + iLen > hwnd.iCol2 THEN
	       iLen = hwnd.iCol2 - iCol
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        WinCloseWindow:
'       ---------------------------------------------------------------------
	SUB WinCloseWindow (hwnd AS WINDOWTYPE, sVio$)
	    sTmp$ = RIGHT$(sVio$, 4)
	    iRow1 = ASC(sTmp$)
	    iCol1 = ASC(RIGHT$(sTmp$, 3))
	    iRow2 = ASC(RIGHT$(sTmp$, 2))
	    iCol2 = ASC(RIGHT$(sTmp$, 1))

	    CALL VioPutWindow(iRow1, iCol1, iRow2, iCol2, LEFT$(sVio$, LEN(sVio$) - 4))

	    CALL RestoreColor(hwnd)

	    sVio$ = ""
	END SUB

'       ---------------------------------------------------------------------
'        WinOpenWindow$
'       ---------------------------------------------------------------------
	FUNCTION WinOpenWindow$ (hwnd AS WINDOWTYPE, iRow1, iCol1, iRowLen, iColLen, sRubrik$, iShade, iZoom, iFrame)

	    iRow2 = iRow1 + iRowLen
	    iCol2 = iCol1 + iColLen

	    CALL QueryDefault(dShade, dZoom, dFrame, fZoomTime!, bf, bb, wf, wb, ff, fb, ef, eb)

	    IF iShade = -1 THEN
	       iShade = dShade
	    END IF

	    IF iFrame = -1 THEN
	       iFrame = dFrame
	    END IF

	    IF iZoom = -1 THEN
	       iZoom = dZoom
	    END IF

	    IF hwnd.efcolor = 0 AND hwnd.ebcolor = 0 THEN
	       hwnd.bfcolor = bf
	       hwnd.bbcolor = bb
	       hwnd.wfcolor = wf
	       hwnd.wbcolor = wb
	       hwnd.ffcolor = ff
	       hwnd.fbcolor = fb
	       hwnd.efcolor = ef
	       hwnd.ebcolor = eb
	    END IF

	    IF iShade = TRUE THEN
	       iRowTo = iRow2 + 1
	       iColFr = iCol1 - 1
	       iColTo = iCol2 + 2
	    ELSE
	       iRowTo = iRow2
	       iColFr = iCol1
	       iColTo = iCol2
	    END IF

	    IF iRow1 < 1 THEN
	       iRow1 = 1
	    END IF
	    IF iRowTo > 25 THEN
	       iRowTo = 25
	    END IF
	    IF iColFr < 1 THEN
	       iColFr = 1
	    END IF
	    IF iColTo > 80 THEN
	       iColTo = 80
	    END IF

	    sVio$ = VioSpace$(iRow1, iColFr, iRowTo, iColTo)
	    CALL VioGetWindow(iRow1, iColFr, iRowTo, iColTo, sVio$)

	    CALL SaveColor(hwnd)

	    IF iZoom = TRUE THEN
	       CALL ZoomWindow(iRow1, iCol1, iRow2, iCol2, VioColor(hwnd.bfcolor, hwnd.wbcolor), iFrame)
	    END IF

	    IF iShade = TRUE THEN
	       CALL VioShade(iRow1, iColFr, iRowTo, iColTo)
	    END IF

	    CALL VioFrame(iRow1, iCol1, iRow2, iCol2, VioColor(hwnd.bfcolor, hwnd.bbcolor), iFrame)

	    CALL VioFrame(iRow1 + 1, iCol1 + 1, iRow2 - 1, iCol2 - 1, VioColor(hwnd.wfcolor, hwnd.wbcolor), 32)

	    sTemp$ = RTRIM$(LTRIM$(sRubrik$))
	    IF sTemp$ <> "" THEN
	       IF iShade = TRUE THEN
		  iColTo = iColTo - 2
		  CALL VioCPrint(iRow1, iColFr + 1, VioColor(hwnd.bbcolor, hwnd.bfcolor), SPACE$(iColTo - iColFr))
	       ELSE
		  CALL VioCPrint(iRow1, iColFr, VioColor(hwnd.bbcolor, hwnd.bfcolor), SPACE$(iColTo - iColFr + 1))
	       END IF
	       
	       IF LEN(sTemp$) > (iCol2 - iCol1 - 1) THEN
		  sTemp$ = LEFT$(sTemp$, (iCol2 - iCol1 - 1))
	       END IF
	       CALL VioPrint(iRow1, iCol1 + 2, sTemp$)
	       IF iShade = TRUE THEN
		  iColTo = iColTo + 2
	       END IF
	    END IF

	    sVio$ = sVio$ + CHR$(iRow1) + CHR$(iColFr) + CHR$(iRowTo) + CHR$(iColTo)

	    hwnd.iRow1 = iRow1
	    hwnd.iCol1 = iCol1
	    hwnd.iRow2 = iRow2
	    hwnd.iCol2 = iCol2

	    WinOpenWindow$ = sVio$

	    sVio$ = ""
	END FUNCTION

'       ---------------------------------------------------------------------
'        WinSetDefault:
'       ---------------------------------------------------------------------
	SUB WinSetDefault (iShade, iZoom, iFrame, fZoomTime!, bf, bb, wf, wb, ff, fb, ef, eb)
	    CALL QueryDefault(nul, nul, nul, nul!, nul, nul, nul, nul, nul, nul, nul, nul)
	    IF VioQueryColor(void) = TRUE THEN
	       st.iGloFrame = iFrame
	       st.iGloShade = iShade
	       st.iGlobfcolor = bf
	       st.iGlobbcolor = bb
	       st.iGlowfcolor = wf
	       st.iGlowbcolor = wb
	       st.iGloffcolor = ff
	       st.iGlofbcolor = fb
	       st.iGloefcolor = ef
	       st.iGloebcolor = eb
	    ELSE
	       st.iGloFrame = 0
	       st.iGloShade = FALSE
	       st.iGlobfcolor = BLACK
	       st.iGlobbcolor = WHITE
	       st.iGlowfcolor = BLACK
	       st.iGlowbcolor = WHITE
	       st.iGloffcolor = BLACK
	       st.iGlofbcolor = BRRED
	       st.iGloefcolor = WHITE
	       st.iGloebcolor = BLACK
	    END IF

	    st.iGloZoom = iZoom
	    st.fGloZoomTime! = fZoomTime!
	    
	END SUB

'       ---------------------------------------------------------------------
'        ZoomWindow: Zooms window.
'       ---------------------------------------------------------------------
	SUB ZoomWindow (iRow1, iCol1, iRow2, iCol2, iColor, iFrame)

	    iRowMitt = iRow1 + ((iRow2 - iRow1) \ 2)
	    iColMitt = iCol1 + ((iCol2 - iCol1) \ 2)

	    IF (iCol2 - iCol1) > (iRow2 - iRow1) THEN
	       iColStep = (iCol2 - iCol1) \ (iRow2 - iRow1)
	       FOR iCounter = 1 TO (iRow2 - iRow1) \ 2
		   iCol = iColStep * iCounter

		   CALL VioFrame(iRowMitt - iCounter, iColMitt - iCol, iRowMitt + iCounter, iColMitt + iCol, iColor, iFrame)

		   tBegin! = TIMER
		   DO
		   LOOP WHILE TIMER < tBegin! + st.fGloZoomTime!

	       NEXT iCounter
	    ELSE
	       iRowStep = (iRow2 - iRow1) \ (iCol2 - iCol1)
	       FOR iCounter = 1 TO (iCol2 - iCol1) \ 2
		   iRow = iRowStep * iCounter

		   CALL VioFrame(iRowMitt - iRow, iColMitt - iCounter, iRowMitt + iRow, iColMitt + iCounter, iColor, iFrame)

		   tBegin! = TIMER
		   DO
		   LOOP WHILE TIMER < tBegin! + .08

	       NEXT iCounter
	    END IF
	END SUB

