DECLARE SUB QueryDefault (iShade%, iZoom%, iFrame%, fZoomTime!, bf%, bb%, wf%, wb%, ff%, fb%, ef%, eb%)
DECLARE SUB ValidPos (hwnd AS ANY, iRow%, iCol%, iLen%)
REM     *********************************************************************
REM     * WPRINT.MOD
REM     *********************************************************************
REM     * Part of WIN.MOD library after split
REM     *
REM     *********************************************************************
REM     * 931107: Split...
REM     *--------------------------------------------------------------------
REM     *********************************************************************
	REM $INCLUDE: 'STLIBVB.BI'
	DEFINT A-Z

'       ---------------------------------------------------------------------
'        WinColorPrint:
'       ---------------------------------------------------------------------
	SUB WinColorPrint (hwnd AS WINDOWTYPE, iRow, iCol, iFc, iBc, sText$)
	    iWinRow = iRow
	    iWinCol = iCol
	    iLen = LEN(sText$)
	    CALL ValidPos(hwnd, iWinRow, iWinCol, iLen)
	    IF VioQueryColor(void) = TRUE THEN
	       CALL VioCPrint(iWinRow, iWinCol, VioColor(iFc, iBc), LEFT$(sText$, iLen))
	    ELSE
	       CALL VioCPrint(iWinRow, iWinCol, VioColor(BLACK, WHITE), LEFT$(sText$, iLen))'
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        WinEditPrint:
'       ---------------------------------------------------------------------
	SUB WinEditPrint (hwnd AS WINDOWTYPE, iRow, iCol, sText$)
	    iWinRow = iRow
	    iWinCol = iCol
	    iLen = LEN(sText$)
	    CALL ValidPos(hwnd, iWinRow, iWinCol, iLen)
	    CALL VioCPrint(iWinRow, iWinCol, VioColor(hwnd.efcolor, hwnd.ebcolor), LEFT$(sText$, iLen))
	END SUB

'       ---------------------------------------------------------------------
'        WinFieldPrint:
'       ---------------------------------------------------------------------
	SUB WinFieldPrint (hwnd AS WINDOWTYPE, iRow, iCol, sText$)
	    iWinRow = iRow
	    iWinCol = iCol
	    iLen = LEN(sText$)
	    CALL ValidPos(hwnd, iWinRow, iWinCol, iLen)
	    CALL VioCPrint(iWinRow, iWinCol, VioColor(hwnd.ffcolor, hwnd.fbcolor), LEFT$(sText$, iLen))
	END SUB

'       ---------------------------------------------------------------------
'        WinFrame:
'       ---------------------------------------------------------------------
	SUB WinFrame (hwnd AS WINDOWTYPE, sTitle$, iRow1, iCol1, iRowTo, iColTo, iLineType)
	    SELECT CASE iLineType
		   CASE 0
			ur = 191
			ul = 218
			ll = 192
			lr = 217
			h = 196
			v = 179
		   CASE 255
			ur = 187
			ul = 201
			ll = 200
			lr = 188
			h = 205
			v = 186
		   CASE ELSE
			ur = iLineType
			ul = iLineType
			ll = iLineType
			lr = iLineType
			h = iLineType
			v = iLineType
	    END SELECT
	
	    CALL WinPrint(hwnd, iRow1, iCol1, CHR$(ul) + STRING$(iColTo - 1, h) + CHR$(ur))
	    FOR iCounter = iRow1 + 1 TO iRow1 + iRowTo - 1
		CALL WinPrint(hwnd, iCounter, iCol1, CHR$(v))
		CALL WinPrint(hwnd, iCounter, iCol1 + iColTo, CHR$(v))
	    NEXT iCounter
	    CALL WinPrint(hwnd, iRow1 + iRowTo, iCol1, CHR$(ll) + STRING$(iColTo - 1, h) + CHR$(lr))
	    IF RTRIM$(sTitle$) <> "" THEN
	       CALL WinPrint(hwnd, iRow1, iCol1 + 1, " " + sTitle$ + " ")
	    END IF
	END SUB

'       ---------------------------------------------------------------------
'        WinPrint:
'       ---------------------------------------------------------------------
	SUB WinPrint (hwnd AS WINDOWTYPE, iRow, iCol, sText$)
	    iWinRow = iRow
	    iWinCol = iCol
	    iLen = LEN(sText$)
	    CALL ValidPos(hwnd, iWinRow, iWinCol, iLen)
	    CALL VioPrint(iWinRow, iWinCol, LEFT$(sText$, iLen))
	END SUB

'       ---------------------------------------------------------------------
'        WinStatusPrint:
'       ---------------------------------------------------------------------
	SUB WinStatusPrint (iCol, iInvers, sText$)
	    CALL QueryDefault(dShade, dZoom, dFrame, fZoomTime!, bf, bb, wf, wb, ff, fb, ef, eb)
	    IF iInvers = TRUE THEN
	       CALL VioCPrint(25, iCol, VioColor(ff, fb), sText$)
	    ELSE
	       CALL VioPrint(25, iCol, sText$)
	    END IF
	END SUB

