REM     *********************************************************************
REM     * MDBLIST.MOD
REM     *********************************************************************
REM     * FUNCTION MDBList
REM     *
REM     *********************************************************************
REM     * 900702: Created
REM     *--------------------------------------------------------------------
REM     * 900702: Changed and added to STLIB7
REM     *********************************************************************
	REM $INCLUDE: 'STLIB.BI'
	DEFINT A-Z

	'------------------------------------------------------------
	' HOW TO USE !
	'
	' 1) Fill MDBLISTTYPE with wanted values
	' 2) Call with 0, return TRUE=OK, FALSE=no records in file
	'    If FALSE either add record and call again or abort
	' 3) RETRIEVE first record and place in string, call with 1.
	'    Call with RETRIEVEd record until it returns TRUE
	' 4) Loop for keypress with 2. If returns -1 then loop with
	'    1 like in 3). If you want to redraw list call with 2
	'    and "REDRAW" in string.
	' 5) To shut down call with 3
	'------------------------------------------------------------

'       --------------------------------------------------------------------
'        MDBList: Lists a MDB file kind of like ListBox.
'       --------------------------------------------------------------------
	FUNCTION MDBList (mdbfunc, ml AS MDBLISTTYPE, temp$) STATIC
	    SELECT CASE mdbfunc
		   CASE 0
			r1 = ml.row1
			c1 = ml.col1
			r2 = ml.row2
			c2 = ml.col2
			handle = ml.handle
			IF ml.frame = TRUE THEN
			   CALL VioFrame(r1, c1, r2, c2, VioColor(-1, -1), 0)
			   CALL VioPrint(r1 + 1, c2, CHR$(24))
			   FOR counter = r1 + 2 TO r2 - 2
			       CALL VioPrint(counter, c2, CHR$(177))
			   NEXT counter
			   CALL VioPrint(r2 - 1, c2, CHR$(25))
			   r1 = r1 + 1
			   c1 = c1 + 1
			   r2 = r2 - 1
			   c2 = c2 - 1
			END IF
			llen = r2 - r1 + 1
			vioclr = VioColor(st.bcolor, st.fcolor)
			CALL VioCPrint(r1, c1, vioclr, SPACE$(c2 - c1 + 1))
			redraw = TRUE
			counter = 0
			antal = 0
			xrow = 0
			skipit = 1000

			MOVEFIRST #handle
			IF LOF(handle) = 0 THEN
			   MDBList = FALSE
			   EXIT FUNCTION
			END IF
			MDBList = TRUE
			EXIT FUNCTION
		   CASE 1
			IF counter = 0 THEN
			   FOR temp = 1 TO xrow
			       MOVEPREVIOUS #handle
			       IF BOF(handle) THEN
				  MOVEFIRST #handle
				  xrow = temp - 1
				  EXIT FOR
			       END IF
			   NEXT
			   IF LOF(handle) < llen THEN
			      llen = LOF(handle)
			   END IF
			   counter = counter + 1
			   MDBList = FALSE
			   EXIT FUNCTION
			END IF
			IF counter <= llen THEN
			   antal = antal + 1
			   temp$ = LEFT$(temp$, c2 - c1 + 1)
			   CALL VioPrint(r1 - 1 + counter, c1, temp$)
			   MOVENEXT #handle
			   IF EOF(handle) THEN
			      IF LOF(handle) < (r2 - r1 + 1) THEN
				 SELECT CASE skipit
					CASE 8
					     MOVELAST #handle
					     skipit = -10
					     xrow = llen - 1
					     counter = 0
					     EXIT FUNCTION
					CASE -10, 1
					     MOVELAST #handle
					     counter = llen + 1
					     xrow = llen
					CASE 10, -1, -8
					     MOVEFIRST #handle
					     counter = llen + 1
					     xrow = 0
					CASE 1000
					     MOVEFIRST #handle
					     counter = llen + 1
					     xrow = 0
					CASE ELSE
				 END SELECT
			      ELSE
				 SELECT CASE skipit
					CASE 8
					     MOVELAST #handle
					     skipit = -10
					     xrow = llen - 1
					     counter = 0
					     MDBList = FALSE
					     EXIT FUNCTION
					CASE -10, 1
					     MOVELAST #handle
					     counter = llen + 1
					     xrow = llen
					CASE 10
					     MOVEFIRST #handle
					     counter = llen + 1
					     xrow = 0
					CASE ELSE
				 END SELECT
			      END IF
			   END IF
			   counter = counter + 1
			   MDBList = FALSE
			   EXIT FUNCTION
			ELSE
			   FOR counter = 1 TO llen - xrow
			       MOVEPREVIOUS #handle
			   NEXT counter
			   FOR fill = antal + 2 TO llen
			       CALL VioPrint(r1 - 1 + fill, c1, SPACE$(c2 - c1 + 1))
			   NEXT fill

			   IF xrow > llen - 1 THEN
			      xrow = llen - 1
			   END IF

			   counter = 0
			   antal = 0
			   MDBList = TRUE
			   EXIT FUNCTION
			END IF
		   CASE 2
			IF temp$ = "REDRAW" THEN
			   xrow = 0
			   counter = 0
			   antal = 0
			   MDBList = -1
			   EXIT FUNCTION
			END IF
			LOCATE r1 + xrow, c1, 1
			vioclr = VioColor(st.fcolor, st.bcolor)
			CALL VioFill(oldr, c1, vioclr, c2 - c1 + 1)
			vioclr = VioColor(st.bcolor, st.fcolor)
			CALL VioFill(r1 + xrow, c1, vioclr, c2 - c1 + 1)
			oldr = r1 + xrow
			CALL KbdInkey(IDKWAIT, scan, nul)
			CALL KbdClear
			LOCATE r1, c1, 0
			SELECT CASE scan
			       CASE KEYUARROW
				    skipit = -1
			       CASE KEYDARROW
				    skipit = 1
			       CASE KEYPAGEUP
				    skipit = -8
			       CASE KEYPAGEDN
				    skipit = 8
			       CASE KEYHOME
				    skipit = 10
			       CASE KEYEND
				    skipit = -10
			       CASE ELSE
				    MDBList = scan
				    temp$ = ""
				    EXIT FUNCTION
			END SELECT
			redraw = FALSE
			SELECT CASE skipit
			       CASE -1
				    MOVEPREVIOUS #handle
				    xrow = xrow - 1
				    IF xrow < 0 THEN
				       redraw = TRUE
				       xrow = 0
				    END IF
			       CASE 1
				    MOVENEXT #handle
				    IF NOT EOF(handle) THEN
				       xrow = xrow + 1
				       IF xrow > (llen - 1) THEN
					  redraw = TRUE
					  xrow = (llen - 1)
				       END IF
				    END IF
			       CASE -8
				    FOR counter = 1 TO llen
					MOVEPREVIOUS #handle
				    NEXT counter
				    redraw = TRUE
			       CASE 8
				    FOR counter = 1 TO llen
					MOVENEXT #handle
				    NEXT counter
				    redraw = TRUE
			       CASE -10
				    MOVELAST #handle
				    xrow = llen - 1
				    redraw = TRUE
			       CASE 10
				    MOVEFIRST #handle
				    xrow = 0
				    redraw = TRUE
			       CASE ELSE
			END SELECT
			IF EOF(handle) THEN
			   xrow = llen - 1
			   MOVELAST #handle
			END IF
			IF BOF(handle) THEN
			   xrow = 0
			   MOVEFIRST #handle
			END IF
			IF redraw = TRUE THEN
			   counter = 0
			   antal = 0
			   MDBList = -1
			ELSE
			   MDBList = scan
			END IF
			temp$ = ""
			EXIT FUNCTION
		   CASE 3

nul = MessageBox(0, IDSINFO, STR$(0), STR$(0), STR$(0))

			' *****  EXIT PROCESSING  ******
		   CASE ELSE
	    END SELECT
	END FUNCTION

